import{s as Dm,n as Fm,o as Lm}from"../chunks/scheduler.9039eef2.js";import{S as zm,i as Im,g as o,s as a,r as s,A as Mm,h as r,f as l,c as n,j as _,u as d,x as i,k as h,y as t,a as v,v as c,d as m,t as p,w as g}from"../chunks/index.ded8f90d.js";import{D as f}from"../chunks/Docstring.2eae8017.js";import{H as D,E as qm}from"../chunks/EditOnGithub.b5540897.js";function Em(Id){let ee,tr,Yo,ar,et,nr,tt,Md=`At TRL we support PPO (Proximal Policy Optimisation) with an implementation that largely follows  the structure introduced in the paper “Fine-Tuning Language Models from Human Preferences” by D. Ziegler et al. [<a href="https://arxiv.org/pdf/1909.08593.pdf" rel="nofollow">paper</a>, <a href="https://github.com/openai/lm-human-preferences" rel="nofollow">code</a>].
The Trainer and model classes are largely inspired from <code>transformers.Trainer</code> and <code>transformers.AutoModel</code> classes and adapted for RL.
We also support a <code>RewardTrainer</code> that can be used to train a reward model.`,or,at,rr,E,nt,Il,Va,qd='CPOConfig collects all training arguments related to the <a href="/docs/trl/main/en/trainer#trl.CPOTrainer">CPOTrainer</a> class.',Ml,Aa,Ed=`Using <code>HfArgumentParser</code> we can turn this class into
<a href="https://docs.python.org/3/library/argparse#module-argparse" rel="nofollow">argparse</a> arguments that can be specified on the
command line.`,lr,ot,ir,x,rt,ql,Ka,Rd="Initialize CPOTrainer.",El,re,lt,Rl,ja,Ud=`Llama tokenizer does satisfy <code>enc(a + b) = enc(a) + enc(b)</code>.
It does ensure <code>enc(a + b) = enc(a) + enc(a + b)[len(enc(a)):]</code>.
Reference:
<a href="https://github.com/EleutherAI/lm-evaluation-harness/pull/531#issuecomment-1595586257" rel="nofollow">https://github.com/EleutherAI/lm-evaluation-harness/pull/531#issuecomment-1595586257</a>`,Ul,A,it,Hl,Sa,Hd="Run the given model on the given batch of inputs, concatenating the chosen and rejected inputs together.",Vl,Wa,Vd="We do this to avoid doing two forward passes, because it’s faster for FSDP.",Al,le,st,Kl,Ga,Ad="Concatenate the chosen and rejected inputs into a single tensor.",jl,ie,dt,Sl,Ba,Kd="Compute the CPO loss for a batch of policy and reference model log probabilities.",Wl,K,ct,Gl,Za,jd=`Overriding built-in evaluation loop to store metrics for each batch.
Prediction/evaluation loop, shared by <code>Trainer.evaluate()</code> and <code>Trainer.predict()</code>.`,Bl,Ja,Sd="Works both with or without labels.",Zl,se,mt,Jl,Qa,Wd="Compute the log probabilities of the given labels under the given logits.",Ql,de,pt,Xl,Xa,Gd="Compute the CPO loss and other metrics for the given batch of inputs for train or test.",Yl,ce,gt,ei,Ya,Bd="Generate samples from the model and reference model for the given batch of inputs.",ti,me,_t,ai,en,Zd="Log <code>logs</code> on the various objects watching training, including stored metrics.",ni,L,ht,oi,tn,Jd="Tokenize a single row from a CPO specific dataset.",ri,an,Qd=`At this stage, we don’t convert to PyTorch tensors yet; we just handle the truncation
in case the prompt + chosen or prompt + rejected responses is/are too long. First
we truncate the prompt; if we’re still too long, we truncate the chosen/rejected.`,li,nn,Xd=`We also create the labels for the chosen/rejected responses, which are of length equal to
the sum of the length of the prompt and the chosen/rejected response, with
label_pad_token_id  for the prompt tokens.`,sr,ut,dr,te,ft,ii,on,Yd="Configuration class for DDPOTrainer",cr,vt,mr,N,bt,si,rn,ec=`The DDPOTrainer uses Deep Diffusion Policy Optimization to optimise diffusion models.
Note, this trainer is heavily inspired by the work here: <a href="https://github.com/kvablack/ddpo-pytorch" rel="nofollow">https://github.com/kvablack/ddpo-pytorch</a>
As of now only Stable Diffusion based pipelines are supported`,di,pe,Tt,ci,ln,tc="Calculate the loss for a batch of an unpacked sample",mi,ge,Ot,pi,sn,ac="Creates and saves a model card for a TRL model.",gi,z,xt,_i,dn,nc="Perform a single step of training.",hi,cn,oc="Side Effects:",ui,mn,rc="<li>Model weights are updated</li> <li>Logs the statistics to the accelerator trackers.</li> <li>If <code>self.image_samples_callback</code> is not None, it will be called with the prompt_image_pairs, global_step, and the accelerator tracker.</li>",fi,_e,$t,vi,pn,lc="Train the model for a given number of epochs",pr,Pt,gr,b,wt,bi,gn,ic="Initialize DPOTrainer.",Ti,he,yt,Oi,_n,sc=`Llama tokenizer does satisfy <code>enc(a + b) = enc(a) + enc(b)</code>.
It does ensure <code>enc(a + b) = enc(a) + enc(a + b)[len(enc(a)):]</code>.
Reference:
<a href="https://github.com/EleutherAI/lm-evaluation-harness/pull/531#issuecomment-1595586257" rel="nofollow">https://github.com/EleutherAI/lm-evaluation-harness/pull/531#issuecomment-1595586257</a>`,xi,ue,Ct,$i,hn,dc="Computes log probabilities of the reference model for a single padded batch of a DPO specific dataset.",Pi,j,kt,wi,un,cc="Run the given model on the given batch of inputs, concatenating the chosen and rejected inputs together.",yi,fn,mc="We do this to avoid doing two forward passes, because it’s faster for FSDP.",Ci,fe,Nt,ki,vn,pc="Concatenate the chosen and rejected inputs into a single tensor.",Ni,ve,Dt,Di,bn,gc="Compute the DPO loss for a batch of policy and reference model log probabilities.",Fi,S,Ft,Li,Tn,_c=`Overriding built-in evaluation loop to store metrics for each batch.
Prediction/evaluation loop, shared by <code>Trainer.evaluate()</code> and <code>Trainer.predict()</code>.`,zi,On,hc="Works both with or without labels.",Ii,be,Lt,Mi,xn,uc="Compute the log probabilities of the given labels under the given logits.",qi,Te,zt,Ei,$n,fc="Compute the DPO loss and other metrics for the given batch of inputs for train or test.",Ri,Oe,It,Ui,Pn,vc="Generate samples from the model and reference model for the given batch of inputs.",Hi,W,Mt,Vi,wn,bc="Returns the evaluation <code>~torch.utils.data.DataLoader</code>.",Ai,yn,Tc="Subclass of transformers.src.transformers.trainer.get_eval_dataloader to precompute <code>ref_log_probs</code>.",Ki,G,qt,ji,Cn,Oc="Returns the training <code>~torch.utils.data.DataLoader</code>.",Si,kn,xc="Subclass of transformers.src.transformers.trainer.get_train_dataloader to precompute <code>ref_log_probs</code>.",Wi,xe,Et,Gi,Nn,$c="Log <code>logs</code> on the various objects watching training, including stored metrics.",Bi,$e,Rt,Zi,Dn,Pc="Context manager for handling null reference model (that is, peft adapter manipulation).",Ji,I,Ut,Qi,Fn,wc="Tokenize a single row from a DPO specific dataset.",Xi,Ln,yc=`At this stage, we don’t convert to PyTorch tensors yet; we just handle the truncation
in case the prompt + chosen or prompt + rejected responses is/are too long. First
we truncate the prompt; if we’re still too long, we truncate the chosen/rejected.`,Yi,zn,Cc=`We also create the labels for the chosen/rejected responses, which are of length equal to
the sum of the length of the prompt and the chosen/rejected response, with
label_pad_token_id  for the prompt tokens.`,_r,Ht,hr,R,Vt,es,In,kc="The IterativeSFTTrainer can be used to finetune models with methods that requires some steps between optimization.",ts,Pe,At,as,Mn,Nc="Run an optimisation step given a list of input_ids, attention_mask, and labels or a list of text and text_labels.",ur,Kt,fr,U,jt,ns,qn,Dc='KTOConfig collects all training arguments related to the <a href="/docs/trl/main/en/trainer#trl.KTOTrainer">KTOTrainer</a> class.',os,En,Fc=`Using <code>HfArgumentParser</code> we can turn this class into
<a href="https://docs.python.org/3/library/argparse#module-argparse" rel="nofollow">argparse</a> arguments that can be specified on the
command line.`,vr,St,br,$,Wt,rs,Rn,Lc="Initialize KTOTrainer.",ls,we,Gt,is,Un,zc="Computes log probabilities of the reference model for a single padded batch of a KTO specific dataset.",ss,B,Bt,ds,Hn,Ic=`Overriding built-in evaluation loop to store metrics for each batch.
Prediction/evaluation loop, shared by <code>Trainer.evaluate()</code> and <code>Trainer.predict()</code>.`,cs,Vn,Mc="Works both with or without labels.",ms,ye,Zt,ps,An,qc="Compute the log probabilities of the given labels under the given logits.",gs,Ce,Jt,_s,Kn,Ec="Compute the KTO loss and other metrics for the given batch of inputs for train or test.",hs,ke,Qt,us,jn,Rc="Generate samples from the model and reference model for the given batch of inputs.",fs,Z,Xt,vs,Sn,Uc="Returns the evaluation <code>~torch.utils.data.DataLoader</code>.",bs,Wn,Hc="Subclass of transformers.src.transformers.trainer.get_eval_dataloader to precompute <code>ref_log_probs</code>.",Ts,J,Yt,Os,Gn,Vc="Returns the training <code>~torch.utils.data.DataLoader</code>.",xs,Bn,Ac="Subclass of transformers.src.transformers.trainer.get_train_dataloader to precompute <code>ref_log_probs</code>.",$s,Ne,ea,Ps,Zn,Kc="Compute the KTO loss for a batch of policy and reference model log probabilities.",ws,De,ta,ys,Jn,jc="Log <code>logs</code> on the various objects watching training, including stored metrics.",Cs,Fe,aa,ks,Qn,Sc="Context manager for handling null reference model (that is, peft adapter manipulation).",Tr,na,Or,H,oa,Ns,Xn,Wc='ORPOConfig collects all training arguments related to the <a href="/docs/trl/main/en/orpo_trainer#trl.ORPOTrainer">ORPOTrainer</a> class.',Ds,Yn,Gc=`Using <code>HfArgumentParser</code> we can turn this class into
<a href="https://docs.python.org/3/library/argparse#module-argparse" rel="nofollow">argparse</a> arguments that can be specified on the
command line.`,xr,ra,$r,P,la,Fs,eo,Bc="Initialize ORPOTrainer.",Ls,Le,ia,zs,to,Zc=`Llama tokenizer does satisfy <code>enc(a + b) = enc(a) + enc(b)</code>.
It does ensure <code>enc(a + b) = enc(a) + enc(a + b)[len(enc(a)):]</code>.
Reference:
<a href="https://github.com/EleutherAI/lm-evaluation-harness/pull/531#issuecomment-1595586257" rel="nofollow">https://github.com/EleutherAI/lm-evaluation-harness/pull/531#issuecomment-1595586257</a>`,Is,Q,sa,Ms,ao,Jc="Run the given model on the given batch of inputs, concatenating the chosen and rejected inputs together.",qs,no,Qc="We do this to avoid doing two forward passes, because it’s faster for FSDP.",Es,ze,da,Rs,oo,Xc="Concatenate the chosen and rejected inputs into a single tensor.",Us,X,ca,Hs,ro,Yc=`Overriding built-in evaluation loop to store metrics for each batch.
Prediction/evaluation loop, shared by <code>Trainer.evaluate()</code> and <code>Trainer.predict()</code>.`,Vs,lo,em="Works both with or without labels.",As,Ie,ma,Ks,io,tm="Compute the log probabilities of the given labels under the given logits.",js,Me,pa,Ss,so,am="Compute the ORPO loss and other metrics for the given batch of inputs for train or test.",Ws,qe,ga,Gs,co,nm="Generate samples from the model and reference model for the given batch of inputs.",Bs,Ee,_a,Zs,mo,om="Log <code>logs</code> on the various objects watching training, including stored metrics.",Js,Re,ha,Qs,po,rm="Compute ORPO’s odds ratio (OR) loss for a batch of policy and reference model log probabilities.",Xs,M,ua,Ys,go,lm="Tokenize a single row from a ORPO specific dataset.",ed,_o,im=`At this stage, we don’t convert to PyTorch tensors yet; we just handle the truncation
in case the prompt + chosen or prompt + rejected responses is/are too long. First
we truncate the prompt; if we’re still too long, we truncate the chosen/rejected.`,td,ho,sm=`We also create the labels for the chosen/rejected responses, which are of length equal to
the sum of the length of the prompt and the chosen/rejected response, with
label_pad_token_id  for the prompt tokens.`,Pr,fa,wr,ae,va,ad,uo,dm="Configuration class for PPOTrainer",yr,ba,Cr,O,Ta,nd,fo,cm=`The PPOTrainer uses Proximal Policy Optimization to optimise language models.
Note, this trainer is heavily inspired by the original OpenAI learning to summarize work here:
<a href="https://github.com/openai/summarize-from-feedback" rel="nofollow">https://github.com/openai/summarize-from-feedback</a>`,od,Ue,Oa,rd,vo,mm="Calculate model outputs in multiple batches.",ld,He,xa,id,bo,pm="Compute per token rewards from scores and KL-penalty.",sd,Ve,$a,dd,To,gm="Creates and saves a model card for a TRL model.",cd,Ae,Pa,md,Oo,_m="Gather stats from all processes. Useful in the context of distributed training.",pd,Ke,wa,gd,xo,hm=`Generate response with the model given the query tensor.
call the <code>generate</code> method of the model.`,_d,je,ya,hd,$o,um="A function that logs all the training stats. Call it at the end of each epoch.",ud,Se,Ca,fd,Po,fm="Calculate policy and value losses.",vd,We,ka,bd,wo,vm="Prepare the dataloader for training.",Td,Ge,Na,Od,yo,bm="Record training step statistics.",xd,Be,Da,$d,Co,Tm="Run a PPO optimisation step given a list of queries, model responses, and rewards.",Pd,Ze,Fa,wd,ko,Om="Train one PPO minibatch",kr,La,Nr,V,za,yd,No,xm='RewardConfig collects all training arguments related to the <a href="/docs/trl/main/en/trainer#trl.RewardTrainer">RewardTrainer</a> class.',Cd,Do,$m=`Using <code>HfArgumentParser</code> we can turn this class into
<a href="https://docs.python.org/3/library/argparse#module-argparse" rel="nofollow">argparse</a> arguments that can be specified on the
command line.`,Dr,Ia,Fr,F,Ma,kd,Fo,Pm=`The RewardTrainer can be used to train your custom Reward Model. It is a subclass of the
<code>transformers.Trainer</code> class and inherits all of its attributes and methods. It is recommended to use
an <code>AutoModelForSequenceClassification</code> as the reward model. The reward model should be trained on a dataset
of paired examples, where each example is a tuple of two sequences. The reward model should be trained to
predict which example in the pair is more relevant to the task at hand.`,Nd,Lo,wm=`The reward trainer expects a very specific format for the dataset. The dataset should contain two 4 entries at least
if you don’t use the default <code>RewardDataCollatorWithPadding</code> data collator. The entries should be named`,Dd,zo,ym="<li><code>input_ids_chosen</code></li> <li><code>attention_mask_chosen</code></li> <li><code>input_ids_rejected</code></li> <li><code>attention_mask_rejected</code></li>",Fd,Io,Cm=`Optionally, you can also pass a <code>margin</code> entry to the dataset. This entry should contain the margin used to modulate the
loss of the reward model as outlined in <a href="https://ai.meta.com/research/publications/llama-2-open-foundation-and-fine-tuned-chat-models/" rel="nofollow">https://ai.meta.com/research/publications/llama-2-open-foundation-and-fine-tuned-chat-models/</a>.
If you don’t pass a margin, no margin will be used.`,Lr,qa,zr,ne,Ea,Ld,Mo,km=`Class definition of the Supervised Finetuning Trainer (SFT Trainer).
This class is a wrapper around the <code>transformers.Trainer</code> class and inherits all of its attributes and methods.
The trainer takes care of properly initializing the PeftModel in case a user passes a <code>PeftConfig</code> object.`,Ir,Ra,Mr,oe,Ua,zd,qo,Nm="Helper function for reproducible behavior to set the seed in <code>random</code>, <code>numpy</code>, and <code>torch</code>.",qr,Ha,Er,er,Rr;return et=new D({props:{title:"Trainer",local:"trainer",headingTag:"h1"}}),at=new D({props:{title:"CPOConfig",local:"trl.CPOConfig",headingTag:"h2"}}),nt=new f({props:{name:"class trl.CPOConfig",anchor:"trl.CPOConfig",parameters:[{name:"output_dir",val:": str"},{name:"overwrite_output_dir",val:": bool = False"},{name:"do_train",val:": bool = False"},{name:"do_eval",val:": bool = False"},{name:"do_predict",val:": bool = False"},{name:"eval_strategy",val:": Union = 'no'"},{name:"prediction_loss_only",val:": bool = False"},{name:"per_device_train_batch_size",val:": int = 8"},{name:"per_device_eval_batch_size",val:": int = 8"},{name:"per_gpu_train_batch_size",val:": Optional = None"},{name:"per_gpu_eval_batch_size",val:": Optional = None"},{name:"gradient_accumulation_steps",val:": int = 1"},{name:"eval_accumulation_steps",val:": Optional = None"},{name:"eval_delay",val:": Optional = 0"},{name:"learning_rate",val:": float = 5e-05"},{name:"weight_decay",val:": float = 0.0"},{name:"adam_beta1",val:": float = 0.9"},{name:"adam_beta2",val:": float = 0.999"},{name:"adam_epsilon",val:": float = 1e-08"},{name:"max_grad_norm",val:": float = 1.0"},{name:"num_train_epochs",val:": float = 3.0"},{name:"max_steps",val:": int = -1"},{name:"lr_scheduler_type",val:": Union = 'linear'"},{name:"lr_scheduler_kwargs",val:": Union = <factory>"},{name:"warmup_ratio",val:": float = 0.0"},{name:"warmup_steps",val:": int = 0"},{name:"log_level",val:": Optional = 'passive'"},{name:"log_level_replica",val:": Optional = 'warning'"},{name:"log_on_each_node",val:": bool = True"},{name:"logging_dir",val:": Optional = None"},{name:"logging_strategy",val:": Union = 'steps'"},{name:"logging_first_step",val:": bool = False"},{name:"logging_steps",val:": float = 500"},{name:"logging_nan_inf_filter",val:": bool = True"},{name:"save_strategy",val:": Union = 'steps'"},{name:"save_steps",val:": float = 500"},{name:"save_total_limit",val:": Optional = None"},{name:"save_safetensors",val:": Optional = True"},{name:"save_on_each_node",val:": bool = False"},{name:"save_only_model",val:": bool = False"},{name:"no_cuda",val:": bool = False"},{name:"use_cpu",val:": bool = False"},{name:"use_mps_device",val:": bool = False"},{name:"seed",val:": int = 42"},{name:"data_seed",val:": Optional = None"},{name:"jit_mode_eval",val:": bool = False"},{name:"use_ipex",val:": bool = False"},{name:"bf16",val:": bool = False"},{name:"fp16",val:": bool = False"},{name:"fp16_opt_level",val:": str = 'O1'"},{name:"half_precision_backend",val:": str = 'auto'"},{name:"bf16_full_eval",val:": bool = False"},{name:"fp16_full_eval",val:": bool = False"},{name:"tf32",val:": Optional = None"},{name:"local_rank",val:": int = -1"},{name:"ddp_backend",val:": Optional = None"},{name:"tpu_num_cores",val:": Optional = None"},{name:"tpu_metrics_debug",val:": bool = False"},{name:"debug",val:": Union = ''"},{name:"dataloader_drop_last",val:": bool = False"},{name:"eval_steps",val:": Optional = None"},{name:"dataloader_num_workers",val:": int = 0"},{name:"dataloader_prefetch_factor",val:": Optional = None"},{name:"past_index",val:": int = -1"},{name:"run_name",val:": Optional = None"},{name:"disable_tqdm",val:": Optional = None"},{name:"remove_unused_columns",val:": Optional = True"},{name:"label_names",val:": Optional = None"},{name:"load_best_model_at_end",val:": Optional = False"},{name:"metric_for_best_model",val:": Optional = None"},{name:"greater_is_better",val:": Optional = None"},{name:"ignore_data_skip",val:": bool = False"},{name:"fsdp",val:": Union = ''"},{name:"fsdp_min_num_params",val:": int = 0"},{name:"fsdp_config",val:": Union = None"},{name:"fsdp_transformer_layer_cls_to_wrap",val:": Optional = None"},{name:"accelerator_config",val:": Union = None"},{name:"deepspeed",val:": Union = None"},{name:"label_smoothing_factor",val:": float = 0.0"},{name:"optim",val:": Union = 'adamw_torch'"},{name:"optim_args",val:": Optional = None"},{name:"adafactor",val:": bool = False"},{name:"group_by_length",val:": bool = False"},{name:"length_column_name",val:": Optional = 'length'"},{name:"report_to",val:": Union = None"},{name:"ddp_find_unused_parameters",val:": Optional = None"},{name:"ddp_bucket_cap_mb",val:": Optional = None"},{name:"ddp_broadcast_buffers",val:": Optional = None"},{name:"dataloader_pin_memory",val:": bool = True"},{name:"dataloader_persistent_workers",val:": bool = False"},{name:"skip_memory_metrics",val:": bool = True"},{name:"use_legacy_prediction_loop",val:": bool = False"},{name:"push_to_hub",val:": bool = False"},{name:"resume_from_checkpoint",val:": Optional = None"},{name:"hub_model_id",val:": Optional = None"},{name:"hub_strategy",val:": Union = 'every_save'"},{name:"hub_token",val:": Optional = None"},{name:"hub_private_repo",val:": bool = False"},{name:"hub_always_push",val:": bool = False"},{name:"gradient_checkpointing",val:": bool = False"},{name:"gradient_checkpointing_kwargs",val:": Union = None"},{name:"include_inputs_for_metrics",val:": bool = False"},{name:"eval_do_concat_batches",val:": bool = True"},{name:"fp16_backend",val:": str = 'auto'"},{name:"evaluation_strategy",val:": Union = None"},{name:"push_to_hub_model_id",val:": Optional = None"},{name:"push_to_hub_organization",val:": Optional = None"},{name:"push_to_hub_token",val:": Optional = None"},{name:"mp_parameters",val:": str = ''"},{name:"auto_find_batch_size",val:": bool = False"},{name:"full_determinism",val:": bool = False"},{name:"torchdynamo",val:": Optional = None"},{name:"ray_scope",val:": Optional = 'last'"},{name:"ddp_timeout",val:": Optional = 1800"},{name:"torch_compile",val:": bool = False"},{name:"torch_compile_backend",val:": Optional = None"},{name:"torch_compile_mode",val:": Optional = None"},{name:"dispatch_batches",val:": Optional = None"},{name:"split_batches",val:": Optional = None"},{name:"include_tokens_per_second",val:": Optional = False"},{name:"include_num_input_tokens_seen",val:": Optional = False"},{name:"neftune_noise_alpha",val:": Optional = None"},{name:"optim_target_modules",val:": Union = None"},{name:"max_length",val:": Optional = None"},{name:"max_prompt_length",val:": Optional = None"},{name:"max_completion_length",val:": Optional = None"},{name:"max_target_length",val:": Optional = None"},{name:"beta",val:": float = 0.1"},{name:"label_smoothing",val:": float = 0"},{name:"loss_type",val:": Literal = 'sigmoid'"},{name:"disable_dropout",val:": bool = True"},{name:"label_pad_token_id",val:": int = -100"},{name:"padding_value",val:": int = None"},{name:"truncation_mode",val:": str = 'keep_end'"},{name:"generate_during_eval",val:": bool = False"},{name:"is_encoder_decoder",val:": Optional = None"},{name:"model_init_kwargs",val:": Optional = None"},{name:"dataset_num_proc",val:": Optional = None"}],parametersDescription:[{anchor:"trl.CPOConfig.max_length",description:`<strong>max_length</strong> (<code>int</code>, defaults to <code>None</code>) &#x2014;
The maximum length of the sequences in the batch. This argument is required if you want to use the default data collator.`,name:"max_length"},{anchor:"trl.CPOConfig.max_prompt_length",description:`<strong>max_prompt_length</strong> (<code>int</code>, defaults to <code>None</code>) &#x2014;
The maximum length of the prompt. This argument is required if you want to use the default data collator.`,name:"max_prompt_length"},{anchor:"trl.CPOConfig.max_target_length",description:`<strong>max_target_length</strong> (<code>int</code>, defaults to <code>None</code>) &#x2014;
The maximum length of the target. This argument is required if you want to use the default data collator and your model is an encoder-decoder.`,name:"max_target_length"},{anchor:"trl.CPOConfig.beta",description:`<strong>beta</strong> (<code>float</code>, defaults to 0.1) &#x2014;
The beta factor in CPO loss.`,name:"beta"},{anchor:"trl.CPOConfig.label_smoothing",description:`<strong>label_smoothing</strong> (<code>float</code>, defaults to 0) &#x2014;
The label smoothing factor. This argument is required if you want to use the default data collator.`,name:"label_smoothing"},{anchor:"trl.CPOConfig.loss_type",description:`<strong>loss_type</strong> (<code>str</code>, defaults to <code>sigmoid</code>) &#x2014;
The type of loss to use. This argument is required if you want to use the default data collator.`,name:"loss_type"},{anchor:"trl.CPOConfig.label_pad_token_id",description:`<strong>label_pad_token_id</strong> (<code>int</code>, defaults to <code>-100</code>) &#x2014;
The label pad token id. This argument is required if you want to use the default data collator.`,name:"label_pad_token_id"},{anchor:"trl.CPOConfig.padding_value",description:`<strong>padding_value</strong> (<code>int</code>, defaults to <code>None</code>) &#x2014;
The padding value if it is different to the tokenizer&#x2019;s pad_token_id.`,name:"padding_value"},{anchor:"trl.CPOConfig.truncation_mode",description:`<strong>truncation_mode</strong> (<code>str</code>, defaults to <code>keep_end</code>) &#x2014;
The truncation mode to use, either <code>keep_end</code> or <code>keep_start</code>. This argument is required if you want to use the default data collator.`,name:"truncation_mode"},{anchor:"trl.CPOConfig.generate_during_eval",description:`<strong>generate_during_eval</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to sample and log generations during evaluation step.`,name:"generate_during_eval"},{anchor:"trl.CPOConfig.is_encoder_decoder",description:`<strong>is_encoder_decoder</strong> (<code>Optional[bool]</code>, <code>optional</code>, defaults to <code>None</code>) &#x2014;
If no model is provided, we need to know if the model_init returns an encoder-decoder.`,name:"is_encoder_decoder"},{anchor:"trl.CPOConfig.disable_dropout",description:`<strong>disable_dropout</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether or not to disable dropouts in <code>model</code>.`,name:"disable_dropout"},{anchor:"trl.CPOConfig.model_init_kwargs",description:`<strong>model_init_kwargs</strong> (<code>Optional[Dict]</code>, <em>optional</em>) &#x2014;
Dict of Optional kwargs to pass when instantiating the model from a string`,name:"model_init_kwargs"},{anchor:"trl.CPOConfig.dataset_num_proc",description:`<strong>dataset_num_proc</strong> (<code>Optional[int]</code>, <em>optional</em>) &#x2014;
The number of workers to use to tokenize the data. Defaults to None.`,name:"dataset_num_proc"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/cpo_config.py#L20"}}),ot=new D({props:{title:"CPOTrainer",local:"trl.CPOTrainer",headingTag:"h2"}}),rt=new f({props:{name:"class trl.CPOTrainer",anchor:"trl.CPOTrainer",parameters:[{name:"model",val:": Union = None"},{name:"args",val:": Optional = None"},{name:"data_collator",val:": Optional = None"},{name:"train_dataset",val:": Optional = None"},{name:"eval_dataset",val:": Union = None"},{name:"tokenizer",val:": Optional = None"},{name:"model_init",val:": Optional = None"},{name:"callbacks",val:": Optional = None"},{name:"optimizers",val:": Tuple = (None, None)"},{name:"preprocess_logits_for_metrics",val:": Optional = None"},{name:"peft_config",val:": Optional = None"},{name:"compute_metrics",val:": Optional = None"}],parametersDescription:[{anchor:"trl.CPOTrainer.model",description:`<strong>model</strong> (<code>transformers.PreTrainedModel</code>) &#x2014;
The model to train, preferably an <code>AutoModelForSequenceClassification</code>.`,name:"model"},{anchor:"trl.CPOTrainer.args",description:`<strong>args</strong> (<code>CPOConfig</code>) &#x2014;
The CPO config arguments to use for training.`,name:"args"},{anchor:"trl.CPOTrainer.data_collator",description:`<strong>data_collator</strong> (<code>transformers.DataCollator</code>) &#x2014;
The data collator to use for training. If None is specified, the default data collator (<code>DPODataCollatorWithPadding</code>) will be used
which will pad the sequences to the maximum length of the sequences in the batch, given a dataset of paired sequences.`,name:"data_collator"},{anchor:"trl.CPOTrainer.train_dataset",description:`<strong>train_dataset</strong> (<code>datasets.Dataset</code>) &#x2014;
The dataset to use for training.`,name:"train_dataset"},{anchor:"trl.CPOTrainer.eval_dataset",description:`<strong>eval_dataset</strong> (<code>datasets.Dataset</code>) &#x2014;
The dataset to use for evaluation.`,name:"eval_dataset"},{anchor:"trl.CPOTrainer.tokenizer",description:`<strong>tokenizer</strong> (<code>transformers.PreTrainedTokenizerBase</code>) &#x2014;
The tokenizer to use for training. This argument is required if you want to use the default data collator.`,name:"tokenizer"},{anchor:"trl.CPOTrainer.model_init",description:`<strong>model_init</strong> (<code>Callable[[], transformers.PreTrainedModel]</code>) &#x2014;
The model initializer to use for training. If None is specified, the default model initializer will be used.`,name:"model_init"},{anchor:"trl.CPOTrainer.callbacks",description:`<strong>callbacks</strong> (<code>List[transformers.TrainerCallback]</code>) &#x2014;
The callbacks to use for training.`,name:"callbacks"},{anchor:"trl.CPOTrainer.optimizers",description:`<strong>optimizers</strong> (<code>Tuple[torch.optim.Optimizer, torch.optim.lr_scheduler.LambdaLR]</code>) &#x2014;
The optimizer and scheduler to use for training.`,name:"optimizers"},{anchor:"trl.CPOTrainer.preprocess_logits_for_metrics",description:`<strong>preprocess_logits_for_metrics</strong> (<code>Callable[[torch.Tensor, torch.Tensor], torch.Tensor]</code>) &#x2014;
The function to use to preprocess the logits before computing the metrics.`,name:"preprocess_logits_for_metrics"},{anchor:"trl.CPOTrainer.peft_config",description:`<strong>peft_config</strong> (<code>Dict</code>, defaults to <code>None</code>) &#x2014;
The PEFT configuration to use for training. If you pass a PEFT configuration, the model will be wrapped in a PEFT model.`,name:"peft_config"},{anchor:"trl.CPOTrainer.compute_metrics",description:`<strong>compute_metrics</strong> (<code>Callable[[EvalPrediction], Dict]</code>, <em>optional</em>) &#x2014;
The function to use to compute the metrics. Must take a <code>EvalPrediction</code> and return
a dictionary string to metric values.`,name:"compute_metrics"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/cpo_trainer.py#L55"}}),lt=new f({props:{name:"build_tokenized_answer",anchor:"trl.CPOTrainer.build_tokenized_answer",parameters:[{name:"prompt",val:""},{name:"answer",val:""}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/cpo_trainer.py#L304"}}),it=new f({props:{name:"concatenated_forward",anchor:"trl.CPOTrainer.concatenated_forward",parameters:[{name:"model",val:": Module"},{name:"batch",val:": Dict"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/cpo_trainer.py#L642"}}),st=new f({props:{name:"concatenated_inputs",anchor:"trl.CPOTrainer.concatenated_inputs",parameters:[{name:"batch",val:": Dict"},{name:"is_encoder_decoder",val:": bool = False"},{name:"label_pad_token_id",val:": int = -100"},{name:"padding_value",val:": int = 0"},{name:"device",val:": Optional = None"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/cpo_trainer.py#L500",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A dictionary containing the concatenated inputs under the key ‘concatenated_input_ids’.</p>
`}}),dt=new f({props:{name:"cpo_loss",anchor:"trl.CPOTrainer.cpo_loss",parameters:[{name:"policy_chosen_logps",val:": FloatTensor"},{name:"policy_rejected_logps",val:": FloatTensor"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/cpo_trainer.py#L562",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>(losses, chosen_rewards, rejected_rewards).
The losses tensor contains the CPO loss for each example in the batch.
The chosen_rewards and rejected_rewards tensors contain the rewards for the chosen and rejected responses, respectively.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A tuple of three tensors</p>
`}}),ct=new f({props:{name:"evaluation_loop",anchor:"trl.CPOTrainer.evaluation_loop",parameters:[{name:"dataloader",val:": DataLoader"},{name:"description",val:": str"},{name:"prediction_loss_only",val:": Optional = None"},{name:"ignore_keys",val:": Optional = None"},{name:"metric_key_prefix",val:": str = 'eval'"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/cpo_trainer.py#L834"}}),mt=new f({props:{name:"get_batch_logps",anchor:"trl.CPOTrainer.get_batch_logps",parameters:[{name:"logits",val:": FloatTensor"},{name:"labels",val:": LongTensor"},{name:"average_log_prob",val:": bool = False"},{name:"label_pad_token_id",val:": int = -100"},{name:"is_encoder_decoder",val:": bool = False"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/cpo_trainer.py#L604",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A tensor of shape (batch_size,) containing the average/sum log probabilities of the given labels under the given logits.</p>
`}}),pt=new f({props:{name:"get_batch_loss_metrics",anchor:"trl.CPOTrainer.get_batch_loss_metrics",parameters:[{name:"model",val:""},{name:"batch",val:": Dict"},{name:"train_eval",val:": Literal = 'train'"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/cpo_trainer.py#L707"}}),gt=new f({props:{name:"get_batch_samples",anchor:"trl.CPOTrainer.get_batch_samples",parameters:[{name:"model",val:""},{name:"batch",val:": Dict"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/cpo_trainer.py#L769"}}),_t=new f({props:{name:"log",anchor:"trl.CPOTrainer.log",parameters:[{name:"logs",val:": Dict"}],parametersDescription:[{anchor:"trl.CPOTrainer.log.logs",description:`<strong>logs</strong> (<code>Dict[str, float]</code>) &#x2014;
The values to log.`,name:"logs"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/cpo_trainer.py#L882"}}),ht=new f({props:{name:"tokenize_row",anchor:"trl.CPOTrainer.tokenize_row",parameters:[{name:"feature",val:""},{name:"model",val:": Union = None"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/cpo_trainer.py#L354"}}),ut=new D({props:{title:"DDPOConfig",local:"trl.DDPOConfig",headingTag:"h2"}}),ft=new f({props:{name:"class trl.DDPOConfig",anchor:"trl.DDPOConfig",parameters:[{name:"exp_name",val:": str = 'doc-buil'"},{name:"run_name",val:": Optional = ''"},{name:"seed",val:": int = 0"},{name:"log_with",val:": Optional = None"},{name:"tracker_kwargs",val:": dict = <factory>"},{name:"accelerator_kwargs",val:": dict = <factory>"},{name:"project_kwargs",val:": dict = <factory>"},{name:"tracker_project_name",val:": str = 'trl'"},{name:"logdir",val:": str = 'logs'"},{name:"num_epochs",val:": int = 100"},{name:"save_freq",val:": int = 1"},{name:"num_checkpoint_limit",val:": int = 5"},{name:"mixed_precision",val:": str = 'fp16'"},{name:"allow_tf32",val:": bool = True"},{name:"resume_from",val:": Optional = ''"},{name:"sample_num_steps",val:": int = 50"},{name:"sample_eta",val:": float = 1.0"},{name:"sample_guidance_scale",val:": float = 5.0"},{name:"sample_batch_size",val:": int = 1"},{name:"sample_num_batches_per_epoch",val:": int = 2"},{name:"train_batch_size",val:": int = 1"},{name:"train_use_8bit_adam",val:": bool = False"},{name:"train_learning_rate",val:": float = 0.0003"},{name:"train_adam_beta1",val:": float = 0.9"},{name:"train_adam_beta2",val:": float = 0.999"},{name:"train_adam_weight_decay",val:": float = 0.0001"},{name:"train_adam_epsilon",val:": float = 1e-08"},{name:"train_gradient_accumulation_steps",val:": int = 1"},{name:"train_max_grad_norm",val:": float = 1.0"},{name:"train_num_inner_epochs",val:": int = 1"},{name:"train_cfg",val:": bool = True"},{name:"train_adv_clip_max",val:": float = 5"},{name:"train_clip_range",val:": float = 0.0001"},{name:"train_timestep_fraction",val:": float = 1.0"},{name:"per_prompt_stat_tracking",val:": bool = False"},{name:"per_prompt_stat_tracking_buffer_size",val:": int = 16"},{name:"per_prompt_stat_tracking_min_count",val:": int = 16"},{name:"async_reward_computation",val:": bool = False"},{name:"max_workers",val:": int = 2"},{name:"negative_prompts",val:": Optional = ''"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ddpo_config.py#L11"}}),vt=new D({props:{title:"DDPOTrainer",local:"trl.DDPOTrainer",headingTag:"h2"}}),bt=new f({props:{name:"class trl.DDPOTrainer",anchor:"trl.DDPOTrainer",parameters:[{name:"config",val:": DDPOConfig"},{name:"reward_function",val:": Callable"},{name:"prompt_function",val:": Callable"},{name:"sd_pipeline",val:": DDPOStableDiffusionPipeline"},{name:"image_samples_hook",val:": Optional = None"}],parametersDescription:[{anchor:"trl.DDPOTrainer.*config**",description:`*<strong>*config**</strong> (<code>DDPOConfig</code>) &#x2014; Configuration object for DDPOTrainer. Check the documentation of <code>PPOConfig</code> for more &#x2014;
details.`,name:"*config**"},{anchor:"trl.DDPOTrainer.*reward_function**",description:"*<strong>*reward_function**</strong> (Callable[[torch.Tensor, Tuple[str], Tuple[Any]], torch.Tensor]) &#x2014; Reward function to be used &#x2014;",name:"*reward_function**"},{anchor:"trl.DDPOTrainer.*prompt_function**",description:"*<strong>*prompt_function**</strong> (Callable[[], Tuple[str, Any]]) &#x2014; Function to generate prompts to guide model &#x2014;",name:"*prompt_function**"},{anchor:"trl.DDPOTrainer.*sd_pipeline**",description:"*<strong>*sd_pipeline**</strong> (<code>DDPOStableDiffusionPipeline</code>) &#x2014; Stable Diffusion pipeline to be used for training. &#x2014;",name:"*sd_pipeline**"},{anchor:"trl.DDPOTrainer.*image_samples_hook**",description:"*<strong>*image_samples_hook**</strong> (Optional[Callable[[Any, Any, Any], Any]]) &#x2014; Hook to be called to log images &#x2014;",name:"*image_samples_hook**"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ddpo_trainer.py#L55"}}),Tt=new f({props:{name:"calculate_loss",anchor:"trl.DDPOTrainer.calculate_loss",parameters:[{name:"latents",val:""},{name:"timesteps",val:""},{name:"next_latents",val:""},{name:"log_probs",val:""},{name:"advantages",val:""},{name:"embeds",val:""}],parametersDescription:[{anchor:"trl.DDPOTrainer.calculate_loss.latents",description:`<strong>latents</strong> (torch.Tensor) &#x2014;
The latents sampled from the diffusion model, shape: [batch_size, num_channels_latents, height, width]`,name:"latents"},{anchor:"trl.DDPOTrainer.calculate_loss.timesteps",description:`<strong>timesteps</strong> (torch.Tensor) &#x2014;
The timesteps sampled from the diffusion model, shape: [batch_size]`,name:"timesteps"},{anchor:"trl.DDPOTrainer.calculate_loss.next_latents",description:`<strong>next_latents</strong> (torch.Tensor) &#x2014;
The next latents sampled from the diffusion model, shape: [batch_size, num_channels_latents, height, width]`,name:"next_latents"},{anchor:"trl.DDPOTrainer.calculate_loss.log_probs",description:`<strong>log_probs</strong> (torch.Tensor) &#x2014;
The log probabilities of the latents, shape: [batch_size]`,name:"log_probs"},{anchor:"trl.DDPOTrainer.calculate_loss.advantages",description:`<strong>advantages</strong> (torch.Tensor) &#x2014;
The advantages of the latents, shape: [batch_size]`,name:"advantages"},{anchor:"trl.DDPOTrainer.calculate_loss.embeds",description:`<strong>embeds</strong> (torch.Tensor) &#x2014;
The embeddings of the prompts, shape: [2*batch_size or batch_size, &#x2026;]
Note: the &#x201C;or&#x201D; is because if train_cfg is True, the expectation is that negative prompts are concatenated to the embeds`,name:"embeds"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ddpo_trainer.py#L340",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>loss (torch.Tensor), approx_kl (torch.Tensor), clipfrac (torch.Tensor)
(all of these are of shape (1,))</p>
`}}),Ot=new f({props:{name:"create_model_card",anchor:"trl.DDPOTrainer.create_model_card",parameters:[{name:"path",val:": str"},{name:"model_name",val:": Optional = 'TRL DDPO Model'"}],parametersDescription:[{anchor:"trl.DDPOTrainer.create_model_card.path",description:"<strong>path</strong> (<code>str</code>) &#x2014; The path to save the model card to.",name:"path"},{anchor:"trl.DDPOTrainer.create_model_card.model_name",description:"<strong>model_name</strong> (<code>str</code>, <em>optional</em>) &#x2014; The name of the model, defaults to <code>TRL DDPO Model</code>.",name:"model_name"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ddpo_trainer.py#L606"}}),xt=new f({props:{name:"step",anchor:"trl.DDPOTrainer.step",parameters:[{name:"epoch",val:": int"},{name:"global_step",val:": int"}],parametersDescription:[{anchor:"trl.DDPOTrainer.step.epoch",description:"<strong>epoch</strong> (int) &#x2014; The current epoch.",name:"epoch"},{anchor:"trl.DDPOTrainer.step.global_step",description:"<strong>global_step</strong> (int) &#x2014; The current global step.",name:"global_step"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ddpo_trainer.py#L234",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The updated global step.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p>global_step (int)</p>
`}}),$t=new f({props:{name:"train",anchor:"trl.DDPOTrainer.train",parameters:[{name:"epochs",val:": Optional = None"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ddpo_trainer.py#L596"}}),Pt=new D({props:{title:"DPOTrainer",local:"trl.DPOTrainer",headingTag:"h2"}}),wt=new f({props:{name:"class trl.DPOTrainer",anchor:"trl.DPOTrainer",parameters:[{name:"model",val:": Union = None"},{name:"ref_model",val:": Union = None"},{name:"beta",val:": float = 0.1"},{name:"label_smoothing",val:": float = 0"},{name:"loss_type",val:": Literal = 'sigmoid'"},{name:"args",val:": Optional = None"},{name:"data_collator",val:": Optional = None"},{name:"label_pad_token_id",val:": int = -100"},{name:"padding_value",val:": Optional = None"},{name:"truncation_mode",val:": str = 'keep_end'"},{name:"train_dataset",val:": Optional = None"},{name:"eval_dataset",val:": Union = None"},{name:"tokenizer",val:": Optional = None"},{name:"model_init",val:": Optional = None"},{name:"callbacks",val:": Optional = None"},{name:"optimizers",val:": Tuple = (None, None)"},{name:"preprocess_logits_for_metrics",val:": Optional = None"},{name:"max_length",val:": Optional = None"},{name:"max_prompt_length",val:": Optional = None"},{name:"max_target_length",val:": Optional = None"},{name:"peft_config",val:": Optional = None"},{name:"is_encoder_decoder",val:": Optional = None"},{name:"disable_dropout",val:": bool = True"},{name:"generate_during_eval",val:": bool = False"},{name:"compute_metrics",val:": Optional = None"},{name:"precompute_ref_log_probs",val:": bool = False"},{name:"dataset_num_proc",val:": Optional = None"},{name:"model_init_kwargs",val:": Optional = None"},{name:"ref_model_init_kwargs",val:": Optional = None"},{name:"model_adapter_name",val:": Optional = None"},{name:"ref_adapter_name",val:": Optional = None"},{name:"reference_free",val:": bool = False"},{name:"force_use_ref_model",val:": bool = False"}],parametersDescription:[{anchor:"trl.DPOTrainer.model",description:`<strong>model</strong> (<code>transformers.PreTrainedModel</code>) &#x2014;
The model to train, preferably an <code>AutoModelForSequenceClassification</code>.`,name:"model"},{anchor:"trl.DPOTrainer.ref_model",description:`<strong>ref_model</strong> (<code>PreTrainedModelWrapper</code>) &#x2014;
Hugging Face transformer model with a casual language modelling head. Used for implicit reward computation and loss. If no
reference model is provided, the trainer will create a reference model with the same architecture as the model to be optimized.`,name:"ref_model"},{anchor:"trl.DPOTrainer.args",description:`<strong>args</strong> (<code>DPOConfig</code>) &#x2014;
The DPO config arguments to use for training.`,name:"args"},{anchor:"trl.DPOTrainer.data_collator",description:`<strong>data_collator</strong> (<code>transformers.DataCollator</code>) &#x2014;
The data collator to use for training. If None is specified, the default data collator (<code>DPODataCollatorWithPadding</code>) will be used
which will pad the sequences to the maximum length of the sequences in the batch, given a dataset of paired sequences.`,name:"data_collator"},{anchor:"trl.DPOTrainer.train_dataset",description:`<strong>train_dataset</strong> (<code>datasets.Dataset</code>) &#x2014;
The dataset to use for training.`,name:"train_dataset"},{anchor:"trl.DPOTrainer.eval_dataset",description:`<strong>eval_dataset</strong> (<code>datasets.Dataset</code>) &#x2014;
The dataset to use for evaluation.`,name:"eval_dataset"},{anchor:"trl.DPOTrainer.tokenizer",description:`<strong>tokenizer</strong> (<code>transformers.PreTrainedTokenizerBase</code>) &#x2014;
The tokenizer to use for training. This argument is required if you want to use the default data collator.`,name:"tokenizer"},{anchor:"trl.DPOTrainer.model_init",description:`<strong>model_init</strong> (<code>Callable[[], transformers.PreTrainedModel]</code>) &#x2014;
The model initializer to use for training. If None is specified, the default model initializer will be used.`,name:"model_init"},{anchor:"trl.DPOTrainer.callbacks",description:`<strong>callbacks</strong> (<code>List[transformers.TrainerCallback]</code>) &#x2014;
The callbacks to use for training.`,name:"callbacks"},{anchor:"trl.DPOTrainer.optimizers",description:`<strong>optimizers</strong> (<code>Tuple[torch.optim.Optimizer, torch.optim.lr_scheduler.LambdaLR]</code>) &#x2014;
The optimizer and scheduler to use for training.`,name:"optimizers"},{anchor:"trl.DPOTrainer.preprocess_logits_for_metrics",description:`<strong>preprocess_logits_for_metrics</strong> (<code>Callable[[torch.Tensor, torch.Tensor], torch.Tensor]</code>) &#x2014;
The function to use to preprocess the logits before computing the metrics.`,name:"preprocess_logits_for_metrics"},{anchor:"trl.DPOTrainer.peft_config",description:`<strong>peft_config</strong> (<code>Dict</code>, defaults to <code>None</code>) &#x2014;
The PEFT configuration to use for training. If you pass a PEFT configuration, the model will be wrapped in a PEFT model.`,name:"peft_config"},{anchor:"trl.DPOTrainer.compute_metrics",description:`<strong>compute_metrics</strong> (<code>Callable[[EvalPrediction], Dict]</code>, <em>optional</em>) &#x2014;
The function to use to compute the metrics. Must take a <code>EvalPrediction</code> and return
a dictionary string to metric values.`,name:"compute_metrics"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L67"}}),yt=new f({props:{name:"build_tokenized_answer",anchor:"trl.DPOTrainer.build_tokenized_answer",parameters:[{name:"prompt",val:""},{name:"answer",val:""}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L666"}}),Ct=new f({props:{name:"compute_reference_log_probs",anchor:"trl.DPOTrainer.compute_reference_log_probs",parameters:[{name:"padded_batch",val:": Dict"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L874"}}),kt=new f({props:{name:"concatenated_forward",anchor:"trl.DPOTrainer.concatenated_forward",parameters:[{name:"model",val:": Module"},{name:"batch",val:": Dict"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L1090"}}),Nt=new f({props:{name:"concatenated_inputs",anchor:"trl.DPOTrainer.concatenated_inputs",parameters:[{name:"batch",val:": Dict"},{name:"is_encoder_decoder",val:": bool = False"},{name:"label_pad_token_id",val:": int = -100"},{name:"padding_value",val:": int = 0"},{name:"device",val:": Optional = None"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L898",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A dictionary containing the concatenated inputs under the key ‘concatenated_input_ids’.</p>
`}}),Dt=new f({props:{name:"dpo_loss",anchor:"trl.DPOTrainer.dpo_loss",parameters:[{name:"policy_chosen_logps",val:": FloatTensor"},{name:"policy_rejected_logps",val:": FloatTensor"},{name:"reference_chosen_logps",val:": FloatTensor"},{name:"reference_rejected_logps",val:": FloatTensor"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L960",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>(losses, chosen_rewards, rejected_rewards).
The losses tensor contains the DPO loss for each example in the batch.
The chosen_rewards and rejected_rewards tensors contain the rewards for the chosen and rejected responses, respectively.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A tuple of three tensors</p>
`}}),Ft=new f({props:{name:"evaluation_loop",anchor:"trl.DPOTrainer.evaluation_loop",parameters:[{name:"dataloader",val:": DataLoader"},{name:"description",val:": str"},{name:"prediction_loss_only",val:": Optional = None"},{name:"ignore_keys",val:": Optional = None"},{name:"metric_key_prefix",val:": str = 'eval'"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L1311"}}),Lt=new f({props:{name:"get_batch_logps",anchor:"trl.DPOTrainer.get_batch_logps",parameters:[{name:"logits",val:": FloatTensor"},{name:"labels",val:": LongTensor"},{name:"average_log_prob",val:": bool = False"},{name:"label_pad_token_id",val:": int = -100"},{name:"is_encoder_decoder",val:": bool = False"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L1052",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A tensor of shape (batch_size,) containing the average/sum log probabilities of the given labels under the given logits.</p>
`}}),zt=new f({props:{name:"get_batch_loss_metrics",anchor:"trl.DPOTrainer.get_batch_loss_metrics",parameters:[{name:"model",val:""},{name:"batch",val:": Dict"},{name:"train_eval",val:": Literal = 'train'"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L1137"}}),It=new f({props:{name:"get_batch_samples",anchor:"trl.DPOTrainer.get_batch_samples",parameters:[{name:"model",val:""},{name:"batch",val:": Dict"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L1221"}}),Mt=new f({props:{name:"get_eval_dataloader",anchor:"trl.DPOTrainer.get_eval_dataloader",parameters:[{name:"eval_dataset",val:": Optional = None"}],parametersDescription:[{anchor:"trl.DPOTrainer.get_eval_dataloader.eval_dataset",description:`<strong>eval_dataset</strong> (<code>torch.utils.data.Dataset</code>, <em>optional</em>) &#x2014;
If provided, will override <code>self.eval_dataset</code>. If it is a <a href="https://huggingface.co/docs/datasets/main/en/package_reference/main_classes#datasets.Dataset" rel="nofollow">Dataset</a>, columns not accepted
by the <code>model.forward()</code> method are automatically removed. It must implement <code>__len__</code>.`,name:"eval_dataset"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L614"}}),qt=new f({props:{name:"get_train_dataloader",anchor:"trl.DPOTrainer.get_train_dataloader",parameters:[],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L571"}}),Et=new f({props:{name:"log",anchor:"trl.DPOTrainer.log",parameters:[{name:"logs",val:": Dict"}],parametersDescription:[{anchor:"trl.DPOTrainer.log.logs",description:`<strong>logs</strong> (<code>Dict[str, float]</code>) &#x2014;
The values to log.`,name:"logs"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L1361"}}),Rt=new f({props:{name:"null_ref_context",anchor:"trl.DPOTrainer.null_ref_context",parameters:[],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L862"}}),Ut=new f({props:{name:"tokenize_row",anchor:"trl.DPOTrainer.tokenize_row",parameters:[{name:"feature",val:""},{name:"model",val:": Union = None"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L716"}}),Ht=new D({props:{title:"IterativeSFTTrainer",local:"trl.IterativeSFTTrainer",headingTag:"h2"}}),Vt=new f({props:{name:"class trl.IterativeSFTTrainer",anchor:"trl.IterativeSFTTrainer",parameters:[{name:"model",val:": Optional = None"},{name:"args",val:": Optional = None"},{name:"tokenizer",val:": Optional = None"},{name:"optimizers",val:": Tuple = (None, None)"},{name:"data_collator",val:": Optional = None"},{name:"eval_dataset",val:": Union = None"},{name:"max_length",val:": Optional = None"},{name:"truncation_mode",val:": Optional = 'keep_end'"},{name:"preprocess_logits_for_metrics",val:": Optional = None"},{name:"compute_metrics",val:": Optional = None"},{name:"optimize_device_cache",val:": Optional = False"}],parametersDescription:[{anchor:"trl.IterativeSFTTrainer.*model**",description:`*<strong>*model**</strong> (<code>PreTrainedModel</code>) &#x2014; Model to be optimized, either an &#x2018;AutoModelForCausalLM&#x2019; or an &#x2018;AutoModelForSeq2SeqLM&#x2019;. &#x2014;
Check the documentation of <code>PreTrainedModel</code> for more details.`,name:"*model**"},{anchor:"trl.IterativeSFTTrainer.*args**",description:"*<strong>*args**</strong> (<code>transformers.TrainingArguments</code>) &#x2014; &#x2014; The arguments to use for training.",name:"*args**"},{anchor:"trl.IterativeSFTTrainer.*tokenizer**",description:`*<strong>*tokenizer**</strong> (<code>PreTrainedTokenizerBase</code>) &#x2014; Tokenizer to be used for encoding the &#x2014;
data. Check the documentation of <code>transformers.PreTrainedTokenizer</code> and
<code>transformers.PreTrainedTokenizerFast</code> for more details.`,name:"*tokenizer**"},{anchor:"trl.IterativeSFTTrainer.*optimizers**",description:"*<strong>*optimizers**</strong> (<code>Tuple[torch.optim.Optimizer, torch.optim.lr_scheduler.LambdaLR]</code>) &#x2014; &#x2014; The optimizer and scheduler to use for training.",name:"*optimizers**"},{anchor:"trl.IterativeSFTTrainer.*data_collator**",description:`*<strong>*data_collator**</strong> (Union[DataCollatorForLanguageModeling, DataCollatorForSeq2Seq], <em>optional</em>) &#x2014; Data collator to be used for training and &#x2014;
passed along the dataloader.`,name:"*data_collator**"},{anchor:"trl.IterativeSFTTrainer.*eval_dataset**",description:"*<strong>*eval_dataset**</strong> (<code>datasets.Dataset</code>) &#x2014; The dataset to use for evaluation.",name:"*eval_dataset**"},{anchor:"trl.IterativeSFTTrainer.*max_length**",description:"*<strong>*max_length**</strong> (<code>int</code>, defaults to <code>None</code>) &#x2014; &#x2014; The maximum length of the input.",name:"*max_length**"},{anchor:"trl.IterativeSFTTrainer.*truncation_mode**",description:"*<strong>*truncation_mode**</strong> (<code>str</code>, defaults to <code>keep_end</code>) &#x2014; &#x2014; The truncation mode to use, either <code>keep_end</code> or <code>keep_start</code>.",name:"*truncation_mode**"},{anchor:"trl.IterativeSFTTrainer.*preprocess_logits_for_metrics**",description:"*<strong>*preprocess_logits_for_metrics**</strong> (<code>Callable[[torch.Tensor, torch.Tensor], torch.Tensor]</code>) &#x2014; &#x2014; The function to use to preprocess the logits before computing the metrics.",name:"*preprocess_logits_for_metrics**"},{anchor:"trl.IterativeSFTTrainer.*compute_metrics**",description:"*<strong>*compute_metrics**</strong> (<code>Callable[[EvalPrediction], Dict]</code>, <em>optional</em>) &#x2014; &#x2014; The function to use to compute the metrics. Must take a <code>EvalPrediction</code> and return a dictionary string to metric values.",name:"*compute_metrics**"},{anchor:"trl.IterativeSFTTrainer.*optimize_device_cache",description:"*<strong>*optimize_device_cache</strong> *<em> (<code>bool</code>, </em>optional*, defaults to <code>False</code>) &#x2014; Optimize CUDA cache for slightly more memory-efficient training. &#x2014;",name:"*optimize_device_cache"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/iterative_sft_trainer.py#L39"}}),At=new f({props:{name:"step",anchor:"trl.IterativeSFTTrainer.step",parameters:[{name:"input_ids",val:": Optional = None"},{name:"attention_mask",val:": Optional = None"},{name:"labels",val:": Optional = None"},{name:"texts",val:": Optional = None"},{name:"texts_labels",val:": Optional = None"}],parametersDescription:[{anchor:"trl.IterativeSFTTrainer.step.input_ids",description:`<strong>input_ids</strong> (List<code>torch.LongTensor</code>) &#x2014;
List of tensors containing the input_ids (if not provided, text will be used)`,name:"input_ids"},{anchor:"trl.IterativeSFTTrainer.step.attention_mask",description:`<strong>attention_mask</strong> (List<code>torch.LongTensor</code>, , <em>optional</em>) &#x2014;
List of tensors containing the attention_mask`,name:"attention_mask"},{anchor:"trl.IterativeSFTTrainer.step.labels",description:`<strong>labels</strong> (List<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
List of tensors containing the labels (if set to None, will default to input_ids)`,name:"labels"},{anchor:"trl.IterativeSFTTrainer.step.texts",description:`<strong>texts</strong> (List<code>str</code>, <em>optional</em>) &#x2014;
List of strings containing the text input (if not provided, input_ids will directly be used)`,name:"texts"},{anchor:"trl.IterativeSFTTrainer.step.texts_labels",description:`<strong>texts_labels</strong> (List<code>str</code>, <em>optional</em>) &#x2014;
List of strings containing the text labels (if set to None, will default to text)`,name:"texts_labels"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/iterative_sft_trainer.py#L229",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A summary of the training statistics</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>dict[str, Any]</code></p>
`}}),Kt=new D({props:{title:"KTOConfig",local:"trl.KTOConfig",headingTag:"h2"}}),jt=new f({props:{name:"class trl.KTOConfig",anchor:"trl.KTOConfig",parameters:[{name:"output_dir",val:": str"},{name:"overwrite_output_dir",val:": bool = False"},{name:"do_train",val:": bool = False"},{name:"do_eval",val:": bool = False"},{name:"do_predict",val:": bool = False"},{name:"eval_strategy",val:": Union = 'no'"},{name:"prediction_loss_only",val:": bool = False"},{name:"per_device_train_batch_size",val:": int = 8"},{name:"per_device_eval_batch_size",val:": int = 8"},{name:"per_gpu_train_batch_size",val:": Optional = None"},{name:"per_gpu_eval_batch_size",val:": Optional = None"},{name:"gradient_accumulation_steps",val:": int = 1"},{name:"eval_accumulation_steps",val:": Optional = None"},{name:"eval_delay",val:": Optional = 0"},{name:"learning_rate",val:": float = 5e-05"},{name:"weight_decay",val:": float = 0.0"},{name:"adam_beta1",val:": float = 0.9"},{name:"adam_beta2",val:": float = 0.999"},{name:"adam_epsilon",val:": float = 1e-08"},{name:"max_grad_norm",val:": float = 1.0"},{name:"num_train_epochs",val:": float = 3.0"},{name:"max_steps",val:": int = -1"},{name:"lr_scheduler_type",val:": Union = 'linear'"},{name:"lr_scheduler_kwargs",val:": Union = <factory>"},{name:"warmup_ratio",val:": float = 0.0"},{name:"warmup_steps",val:": int = 0"},{name:"log_level",val:": Optional = 'passive'"},{name:"log_level_replica",val:": Optional = 'warning'"},{name:"log_on_each_node",val:": bool = True"},{name:"logging_dir",val:": Optional = None"},{name:"logging_strategy",val:": Union = 'steps'"},{name:"logging_first_step",val:": bool = False"},{name:"logging_steps",val:": float = 500"},{name:"logging_nan_inf_filter",val:": bool = True"},{name:"save_strategy",val:": Union = 'steps'"},{name:"save_steps",val:": float = 500"},{name:"save_total_limit",val:": Optional = None"},{name:"save_safetensors",val:": Optional = True"},{name:"save_on_each_node",val:": bool = False"},{name:"save_only_model",val:": bool = False"},{name:"no_cuda",val:": bool = False"},{name:"use_cpu",val:": bool = False"},{name:"use_mps_device",val:": bool = False"},{name:"seed",val:": int = 42"},{name:"data_seed",val:": Optional = None"},{name:"jit_mode_eval",val:": bool = False"},{name:"use_ipex",val:": bool = False"},{name:"bf16",val:": bool = False"},{name:"fp16",val:": bool = False"},{name:"fp16_opt_level",val:": str = 'O1'"},{name:"half_precision_backend",val:": str = 'auto'"},{name:"bf16_full_eval",val:": bool = False"},{name:"fp16_full_eval",val:": bool = False"},{name:"tf32",val:": Optional = None"},{name:"local_rank",val:": int = -1"},{name:"ddp_backend",val:": Optional = None"},{name:"tpu_num_cores",val:": Optional = None"},{name:"tpu_metrics_debug",val:": bool = False"},{name:"debug",val:": Union = ''"},{name:"dataloader_drop_last",val:": bool = False"},{name:"eval_steps",val:": Optional = None"},{name:"dataloader_num_workers",val:": int = 0"},{name:"dataloader_prefetch_factor",val:": Optional = None"},{name:"past_index",val:": int = -1"},{name:"run_name",val:": Optional = None"},{name:"disable_tqdm",val:": Optional = None"},{name:"remove_unused_columns",val:": Optional = True"},{name:"label_names",val:": Optional = None"},{name:"load_best_model_at_end",val:": Optional = False"},{name:"metric_for_best_model",val:": Optional = None"},{name:"greater_is_better",val:": Optional = None"},{name:"ignore_data_skip",val:": bool = False"},{name:"fsdp",val:": Union = ''"},{name:"fsdp_min_num_params",val:": int = 0"},{name:"fsdp_config",val:": Union = None"},{name:"fsdp_transformer_layer_cls_to_wrap",val:": Optional = None"},{name:"accelerator_config",val:": Union = None"},{name:"deepspeed",val:": Union = None"},{name:"label_smoothing_factor",val:": float = 0.0"},{name:"optim",val:": Union = 'adamw_torch'"},{name:"optim_args",val:": Optional = None"},{name:"adafactor",val:": bool = False"},{name:"group_by_length",val:": bool = False"},{name:"length_column_name",val:": Optional = 'length'"},{name:"report_to",val:": Union = None"},{name:"ddp_find_unused_parameters",val:": Optional = None"},{name:"ddp_bucket_cap_mb",val:": Optional = None"},{name:"ddp_broadcast_buffers",val:": Optional = None"},{name:"dataloader_pin_memory",val:": bool = True"},{name:"dataloader_persistent_workers",val:": bool = False"},{name:"skip_memory_metrics",val:": bool = True"},{name:"use_legacy_prediction_loop",val:": bool = False"},{name:"push_to_hub",val:": bool = False"},{name:"resume_from_checkpoint",val:": Optional = None"},{name:"hub_model_id",val:": Optional = None"},{name:"hub_strategy",val:": Union = 'every_save'"},{name:"hub_token",val:": Optional = None"},{name:"hub_private_repo",val:": bool = False"},{name:"hub_always_push",val:": bool = False"},{name:"gradient_checkpointing",val:": bool = False"},{name:"gradient_checkpointing_kwargs",val:": Union = None"},{name:"include_inputs_for_metrics",val:": bool = False"},{name:"eval_do_concat_batches",val:": bool = True"},{name:"fp16_backend",val:": str = 'auto'"},{name:"evaluation_strategy",val:": Union = None"},{name:"push_to_hub_model_id",val:": Optional = None"},{name:"push_to_hub_organization",val:": Optional = None"},{name:"push_to_hub_token",val:": Optional = None"},{name:"mp_parameters",val:": str = ''"},{name:"auto_find_batch_size",val:": bool = False"},{name:"full_determinism",val:": bool = False"},{name:"torchdynamo",val:": Optional = None"},{name:"ray_scope",val:": Optional = 'last'"},{name:"ddp_timeout",val:": Optional = 1800"},{name:"torch_compile",val:": bool = False"},{name:"torch_compile_backend",val:": Optional = None"},{name:"torch_compile_mode",val:": Optional = None"},{name:"dispatch_batches",val:": Optional = None"},{name:"split_batches",val:": Optional = None"},{name:"include_tokens_per_second",val:": Optional = False"},{name:"include_num_input_tokens_seen",val:": Optional = False"},{name:"neftune_noise_alpha",val:": Optional = None"},{name:"optim_target_modules",val:": Union = None"},{name:"max_length",val:": Optional = None"},{name:"max_prompt_length",val:": Optional = None"},{name:"max_completion_length",val:": Optional = None"},{name:"beta",val:": float = 0.1"},{name:"desirable_weight",val:": Optional = 1.0"},{name:"undesirable_weight",val:": Optional = 1.0"},{name:"label_pad_token_id",val:": int = -100"},{name:"padding_value",val:": int = None"},{name:"truncation_mode",val:": str = 'keep_end'"},{name:"generate_during_eval",val:": bool = False"},{name:"is_encoder_decoder",val:": Optional = None"},{name:"precompute_ref_log_probs",val:": bool = False"},{name:"model_init_kwargs",val:": Optional = None"},{name:"ref_model_init_kwargs",val:": Optional = None"},{name:"dataset_num_proc",val:": Optional = None"}],parametersDescription:[{anchor:"trl.KTOConfig.max_length",description:`<strong>max_length</strong> (<code>int</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
The maximum length of the sequences in the batch. This argument is required if you want to use the default data collator.`,name:"max_length"},{anchor:"trl.KTOConfig.max_prompt_length",description:`<strong>max_prompt_length</strong> (<code>int</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
The maximum length of the prompt. This argument is required if you want to use the default data collator.`,name:"max_prompt_length"},{anchor:"trl.KTOConfig.max_completion_length",description:`<strong>max_completion_length</strong> (<code>int</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
The maximum length of the target. This argument is required if you want to use the default data collator and your model is an encoder-decoder.`,name:"max_completion_length"},{anchor:"trl.KTOConfig.beta",description:`<strong>beta</strong> (<code>float</code>, defaults to 0.1) &#x2014;
The beta factor in KTO loss. Higher beta means less divergence from the initial policy.`,name:"beta"},{anchor:"trl.KTOConfig.desirable_weight",description:`<strong>desirable_weight</strong> (<code>float</code>, <em>optional</em>, defaults to 1.0) &#x2014;
The desirable losses are weighed by this factor to counter unequal number of desirable and undesirable paris.`,name:"desirable_weight"},{anchor:"trl.KTOConfig.undesirable_weight",description:`<strong>undesirable_weight</strong> (<code>float</code>, <em>optional</em>, defaults to 1.0) &#x2014;
The undesirable losses are weighed by this factor to counter unequal number of desirable and undesirable pairs.`,name:"undesirable_weight"},{anchor:"trl.KTOConfig.label_pad_token_id",description:`<strong>label_pad_token_id</strong> (<code>int</code>, defaults to <code>-100</code>) &#x2014;
The label pad token id. This argument is required if you want to use the default data collator.`,name:"label_pad_token_id"},{anchor:"trl.KTOConfig.padding_value",description:`<strong>padding_value</strong> (<code>int</code>, defaults to <code>0</code>) &#x2014;
The padding value if it is different to the tokenizer&#x2019;s pad_token_id.`,name:"padding_value"},{anchor:"trl.KTOConfig.truncation_mode",description:`<strong>truncation_mode</strong> (<code>str</code>, defaults to <code>keep_end</code>) &#x2014;
The truncation mode to use, either <code>keep_end</code> or <code>keep_start</code>. This argument is required if you want to use the default data collator.`,name:"truncation_mode"},{anchor:"trl.KTOConfig.generate_during_eval",description:`<strong>generate_during_eval</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to sample and log generations during evaluation step.`,name:"generate_during_eval"},{anchor:"trl.KTOConfig.is_encoder_decoder",description:`<strong>is_encoder_decoder</strong> (<code>Optional[bool]</code>, <code>optional</code>, defaults to <code>None</code>) &#x2014;
If no model is provided, we need to know if the model_init returns an encoder-decoder.`,name:"is_encoder_decoder"},{anchor:"trl.KTOConfig.precompute_ref_log_probs",description:`<strong>precompute_ref_log_probs</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Flag to precompute reference model log probabilities for training and evaluation datasets. This is useful if you want to train
without the reference model and reduce the total GPU memory needed.
model_init_kwargs &#x2014; (<code>Optional[Dict]</code>, <em>optional</em>):
Dict of Optional kwargs to pass when instantiating the model from a string.
ref_model_init_kwargs &#x2014; (<code>Optional[Dict]</code>, <em>optional</em>):
Dict of Optional kwargs to pass when instantiating the ref model from a string.
dataset_num_proc &#x2014; (<code>Optional[int]</code>, <em>optional</em>, defaults to <code>None</code>):
Number of processes to use for processing the datasets.`,name:"precompute_ref_log_probs"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/kto_config.py#L20"}}),St=new D({props:{title:"KTOTrainer",local:"trl.KTOTrainer",headingTag:"h2"}}),Wt=new f({props:{name:"class trl.KTOTrainer",anchor:"trl.KTOTrainer",parameters:[{name:"model",val:": Union = None"},{name:"ref_model",val:": Union = None"},{name:"args",val:": KTOConfig = None"},{name:"train_dataset",val:": Optional = None"},{name:"eval_dataset",val:": Union = None"},{name:"tokenizer",val:": Optional = None"},{name:"data_collator",val:": Optional = None"},{name:"model_init",val:": Optional = None"},{name:"callbacks",val:": Optional = None"},{name:"optimizers",val:": Tuple = (None, None)"},{name:"preprocess_logits_for_metrics",val:": Optional = None"},{name:"peft_config",val:": Optional = None"},{name:"compute_metrics",val:": Optional = None"},{name:"model_adapter_name",val:": Optional = None"},{name:"ref_adapter_name",val:": Optional = None"}],parametersDescription:[{anchor:"trl.KTOTrainer.model",description:`<strong>model</strong> (<code>transformers.PreTrainedModel</code>) &#x2014;
The model to train, preferably an <code>AutoModelForSequenceClassification</code>.`,name:"model"},{anchor:"trl.KTOTrainer.ref_model",description:`<strong>ref_model</strong> (<code>PreTrainedModelWrapper</code>) &#x2014;
Hugging Face transformer model with a casual language modelling head. Used for implicit reward computation and loss. If no
reference model is provided, the trainer will create a reference model with the same architecture as the model to be optimized.`,name:"ref_model"},{anchor:"trl.KTOTrainer.args",description:`<strong>args</strong> (<code>KTOConfig</code>) &#x2014;
The arguments to use for training.`,name:"args"},{anchor:"trl.KTOTrainer.train_dataset",description:`<strong>train_dataset</strong> (<code>datasets.Dataset</code>) &#x2014;
The dataset to use for training.`,name:"train_dataset"},{anchor:"trl.KTOTrainer.eval_dataset",description:`<strong>eval_dataset</strong> (<code>datasets.Dataset</code>) &#x2014;
The dataset to use for evaluation.`,name:"eval_dataset"},{anchor:"trl.KTOTrainer.tokenizer",description:`<strong>tokenizer</strong> (<code>transformers.PreTrainedTokenizerBase</code>) &#x2014;
The tokenizer to use for training. This argument is required if you want to use the default data collator.`,name:"tokenizer"},{anchor:"trl.KTOTrainer.data_collator",description:`<strong>data_collator</strong> (<code>transformers.DataCollator</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
The data collator to use for training. If None is specified, the default data collator (<code>DPODataCollatorWithPadding</code>) will be used
which will pad the sequences to the maximum length of the sequences in the batch, given a dataset of paired sequences.`,name:"data_collator"},{anchor:"trl.KTOTrainer.model_init",description:`<strong>model_init</strong> (<code>Callable[[], transformers.PreTrainedModel]</code>) &#x2014;
The model initializer to use for training. If None is specified, the default model initializer will be used.`,name:"model_init"},{anchor:"trl.KTOTrainer.callbacks",description:`<strong>callbacks</strong> (<code>List[transformers.TrainerCallback]</code>) &#x2014;
The callbacks to use for training.`,name:"callbacks"},{anchor:"trl.KTOTrainer.optimizers",description:`<strong>optimizers</strong> (<code>Tuple[torch.optim.Optimizer, torch.optim.lr_scheduler.LambdaLR]</code>) &#x2014;
The optimizer and scheduler to use for training.`,name:"optimizers"},{anchor:"trl.KTOTrainer.preprocess_logits_for_metrics",description:`<strong>preprocess_logits_for_metrics</strong> (<code>Callable[[torch.Tensor, torch.Tensor], torch.Tensor]</code>) &#x2014;
The function to use to preprocess the logits before computing the metrics.`,name:"preprocess_logits_for_metrics"},{anchor:"trl.KTOTrainer.peft_config",description:`<strong>peft_config</strong> (<code>Dict</code>, defaults to <code>None</code>) &#x2014;
The PEFT configuration to use for training. If you pass a PEFT configuration, the model will be wrapped in a PEFT model.`,name:"peft_config"},{anchor:"trl.KTOTrainer.disable_dropout",description:`<strong>disable_dropout</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether or not to disable dropouts in <code>model</code> and <code>ref_model</code>.`,name:"disable_dropout"},{anchor:"trl.KTOTrainer.compute_metrics",description:`<strong>compute_metrics</strong> (<code>Callable[[EvalPrediction], Dict]</code>, <em>optional</em>) &#x2014;
The function to use to compute the metrics. Must take a <code>EvalPrediction</code> and return
a dictionary string to metric values.`,name:"compute_metrics"},{anchor:"trl.KTOTrainer.model_adapter_name",description:`<strong>model_adapter_name</strong> (<code>str</code>, defaults to <code>None</code>) &#x2014;
Name of the train target PEFT adapter, when using LoRA with multiple adapters.`,name:"model_adapter_name"},{anchor:"trl.KTOTrainer.ref_adapter_name",description:`<strong>ref_adapter_name</strong> (<code>str</code>, defaults to <code>None</code>) &#x2014;
Name of the reference PEFT adapter, when using LoRA with multiple adapters.`,name:"ref_adapter_name"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/kto_trainer.py#L224"}}),Gt=new f({props:{name:"compute_reference_log_probs",anchor:"trl.KTOTrainer.compute_reference_log_probs",parameters:[{name:"padded_batch",val:": Dict"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/kto_trainer.py#L794"}}),Bt=new f({props:{name:"evaluation_loop",anchor:"trl.KTOTrainer.evaluation_loop",parameters:[{name:"dataloader",val:": DataLoader"},{name:"description",val:": str"},{name:"prediction_loss_only",val:": Optional = None"},{name:"ignore_keys",val:": Optional = None"},{name:"metric_key_prefix",val:": str = 'eval'"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/kto_trainer.py#L1217"}}),Zt=new f({props:{name:"get_batch_logps",anchor:"trl.KTOTrainer.get_batch_logps",parameters:[{name:"logits",val:": FloatTensor"},{name:"labels",val:": LongTensor"},{name:"average_log_prob",val:": bool = False"},{name:"label_pad_token_id",val:": int = -100"},{name:"is_encoder_decoder",val:": bool = False"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/kto_trainer.py#L866",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A tensor of shape (batch_size,) containing the average/sum log probabilities of the given labels under the given logits.</p>
`}}),Jt=new f({props:{name:"get_batch_loss_metrics",anchor:"trl.KTOTrainer.get_batch_loss_metrics",parameters:[{name:"model",val:""},{name:"batch",val:": Dict"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/kto_trainer.py#L1022"}}),Qt=new f({props:{name:"get_batch_samples",anchor:"trl.KTOTrainer.get_batch_samples",parameters:[{name:"model",val:""},{name:"batch",val:": Dict"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/kto_trainer.py#L1131"}}),Xt=new f({props:{name:"get_eval_dataloader",anchor:"trl.KTOTrainer.get_eval_dataloader",parameters:[{name:"eval_dataset",val:": Optional = None"}],parametersDescription:[{anchor:"trl.KTOTrainer.get_eval_dataloader.eval_dataset",description:`<strong>eval_dataset</strong> (<code>torch.utils.data.Dataset</code>, <em>optional</em>) &#x2014;
If provided, will override <code>self.eval_dataset</code>. If it is a <a href="https://huggingface.co/docs/datasets/main/en/package_reference/main_classes#datasets.Dataset" rel="nofollow">Dataset</a>, columns not accepted
by the <code>model.forward()</code> method are automatically removed. It must implement <code>__len__</code>.`,name:"eval_dataset"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/kto_trainer.py#L741"}}),Yt=new f({props:{name:"get_train_dataloader",anchor:"trl.KTOTrainer.get_train_dataloader",parameters:[],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/kto_trainer.py#L700"}}),ea=new f({props:{name:"kto_loss",anchor:"trl.KTOTrainer.kto_loss",parameters:[{name:"policy_chosen_logps",val:": FloatTensor"},{name:"policy_rejected_logps",val:": FloatTensor"},{name:"policy_KL_logps",val:": FloatTensor"},{name:"reference_chosen_logps",val:": FloatTensor"},{name:"reference_rejected_logps",val:": FloatTensor"},{name:"reference_KL_logps",val:": FloatTensor"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/kto_trainer.py#L969",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>(losses, chosen_rewards, rejected_rewards, KL).
The losses tensor contains the KTO loss for each example in the batch.
The chosen_rewards and rejected_rewards tensors contain the rewards for the chosen and rejected responses, respectively.
The KL tensor contains the detached KL divergence estimate between the policy and reference models.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A tuple of four tensors</p>
`}}),ta=new f({props:{name:"log",anchor:"trl.KTOTrainer.log",parameters:[{name:"logs",val:": Dict"}],parametersDescription:[{anchor:"trl.KTOTrainer.log.logs",description:`<strong>logs</strong> (<code>Dict[str, float]</code>) &#x2014;
The values to log.`,name:"logs"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/kto_trainer.py#L1273"}}),aa=new f({props:{name:"null_ref_context",anchor:"trl.KTOTrainer.null_ref_context",parameters:[],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/kto_trainer.py#L688"}}),na=new D({props:{title:"ORPOConfig",local:"trl.ORPOConfig",headingTag:"h2"}}),oa=new f({props:{name:"class trl.ORPOConfig",anchor:"trl.ORPOConfig",parameters:[{name:"output_dir",val:": str"},{name:"overwrite_output_dir",val:": bool = False"},{name:"do_train",val:": bool = False"},{name:"do_eval",val:": bool = False"},{name:"do_predict",val:": bool = False"},{name:"eval_strategy",val:": Union = 'no'"},{name:"prediction_loss_only",val:": bool = False"},{name:"per_device_train_batch_size",val:": int = 8"},{name:"per_device_eval_batch_size",val:": int = 8"},{name:"per_gpu_train_batch_size",val:": Optional = None"},{name:"per_gpu_eval_batch_size",val:": Optional = None"},{name:"gradient_accumulation_steps",val:": int = 1"},{name:"eval_accumulation_steps",val:": Optional = None"},{name:"eval_delay",val:": Optional = 0"},{name:"learning_rate",val:": float = 5e-05"},{name:"weight_decay",val:": float = 0.0"},{name:"adam_beta1",val:": float = 0.9"},{name:"adam_beta2",val:": float = 0.999"},{name:"adam_epsilon",val:": float = 1e-08"},{name:"max_grad_norm",val:": float = 1.0"},{name:"num_train_epochs",val:": float = 3.0"},{name:"max_steps",val:": int = -1"},{name:"lr_scheduler_type",val:": Union = 'linear'"},{name:"lr_scheduler_kwargs",val:": Union = <factory>"},{name:"warmup_ratio",val:": float = 0.0"},{name:"warmup_steps",val:": int = 0"},{name:"log_level",val:": Optional = 'passive'"},{name:"log_level_replica",val:": Optional = 'warning'"},{name:"log_on_each_node",val:": bool = True"},{name:"logging_dir",val:": Optional = None"},{name:"logging_strategy",val:": Union = 'steps'"},{name:"logging_first_step",val:": bool = False"},{name:"logging_steps",val:": float = 500"},{name:"logging_nan_inf_filter",val:": bool = True"},{name:"save_strategy",val:": Union = 'steps'"},{name:"save_steps",val:": float = 500"},{name:"save_total_limit",val:": Optional = None"},{name:"save_safetensors",val:": Optional = True"},{name:"save_on_each_node",val:": bool = False"},{name:"save_only_model",val:": bool = False"},{name:"no_cuda",val:": bool = False"},{name:"use_cpu",val:": bool = False"},{name:"use_mps_device",val:": bool = False"},{name:"seed",val:": int = 42"},{name:"data_seed",val:": Optional = None"},{name:"jit_mode_eval",val:": bool = False"},{name:"use_ipex",val:": bool = False"},{name:"bf16",val:": bool = False"},{name:"fp16",val:": bool = False"},{name:"fp16_opt_level",val:": str = 'O1'"},{name:"half_precision_backend",val:": str = 'auto'"},{name:"bf16_full_eval",val:": bool = False"},{name:"fp16_full_eval",val:": bool = False"},{name:"tf32",val:": Optional = None"},{name:"local_rank",val:": int = -1"},{name:"ddp_backend",val:": Optional = None"},{name:"tpu_num_cores",val:": Optional = None"},{name:"tpu_metrics_debug",val:": bool = False"},{name:"debug",val:": Union = ''"},{name:"dataloader_drop_last",val:": bool = False"},{name:"eval_steps",val:": Optional = None"},{name:"dataloader_num_workers",val:": int = 0"},{name:"dataloader_prefetch_factor",val:": Optional = None"},{name:"past_index",val:": int = -1"},{name:"run_name",val:": Optional = None"},{name:"disable_tqdm",val:": Optional = None"},{name:"remove_unused_columns",val:": Optional = True"},{name:"label_names",val:": Optional = None"},{name:"load_best_model_at_end",val:": Optional = False"},{name:"metric_for_best_model",val:": Optional = None"},{name:"greater_is_better",val:": Optional = None"},{name:"ignore_data_skip",val:": bool = False"},{name:"fsdp",val:": Union = ''"},{name:"fsdp_min_num_params",val:": int = 0"},{name:"fsdp_config",val:": Union = None"},{name:"fsdp_transformer_layer_cls_to_wrap",val:": Optional = None"},{name:"accelerator_config",val:": Union = None"},{name:"deepspeed",val:": Union = None"},{name:"label_smoothing_factor",val:": float = 0.0"},{name:"optim",val:": Union = 'adamw_torch'"},{name:"optim_args",val:": Optional = None"},{name:"adafactor",val:": bool = False"},{name:"group_by_length",val:": bool = False"},{name:"length_column_name",val:": Optional = 'length'"},{name:"report_to",val:": Union = None"},{name:"ddp_find_unused_parameters",val:": Optional = None"},{name:"ddp_bucket_cap_mb",val:": Optional = None"},{name:"ddp_broadcast_buffers",val:": Optional = None"},{name:"dataloader_pin_memory",val:": bool = True"},{name:"dataloader_persistent_workers",val:": bool = False"},{name:"skip_memory_metrics",val:": bool = True"},{name:"use_legacy_prediction_loop",val:": bool = False"},{name:"push_to_hub",val:": bool = False"},{name:"resume_from_checkpoint",val:": Optional = None"},{name:"hub_model_id",val:": Optional = None"},{name:"hub_strategy",val:": Union = 'every_save'"},{name:"hub_token",val:": Optional = None"},{name:"hub_private_repo",val:": bool = False"},{name:"hub_always_push",val:": bool = False"},{name:"gradient_checkpointing",val:": bool = False"},{name:"gradient_checkpointing_kwargs",val:": Union = None"},{name:"include_inputs_for_metrics",val:": bool = False"},{name:"eval_do_concat_batches",val:": bool = True"},{name:"fp16_backend",val:": str = 'auto'"},{name:"evaluation_strategy",val:": Union = None"},{name:"push_to_hub_model_id",val:": Optional = None"},{name:"push_to_hub_organization",val:": Optional = None"},{name:"push_to_hub_token",val:": Optional = None"},{name:"mp_parameters",val:": str = ''"},{name:"auto_find_batch_size",val:": bool = False"},{name:"full_determinism",val:": bool = False"},{name:"torchdynamo",val:": Optional = None"},{name:"ray_scope",val:": Optional = 'last'"},{name:"ddp_timeout",val:": Optional = 1800"},{name:"torch_compile",val:": bool = False"},{name:"torch_compile_backend",val:": Optional = None"},{name:"torch_compile_mode",val:": Optional = None"},{name:"dispatch_batches",val:": Optional = None"},{name:"split_batches",val:": Optional = None"},{name:"include_tokens_per_second",val:": Optional = False"},{name:"include_num_input_tokens_seen",val:": Optional = False"},{name:"neftune_noise_alpha",val:": Optional = None"},{name:"optim_target_modules",val:": Union = None"},{name:"max_length",val:": Optional = None"},{name:"max_prompt_length",val:": Optional = None"},{name:"max_completion_length",val:": Optional = None"},{name:"beta",val:": float = 0.1"},{name:"disable_dropout",val:": bool = True"},{name:"label_pad_token_id",val:": int = -100"},{name:"padding_value",val:": int = None"},{name:"truncation_mode",val:": str = 'keep_end'"},{name:"generate_during_eval",val:": bool = False"},{name:"is_encoder_decoder",val:": Optional = None"},{name:"model_init_kwargs",val:": Optional = None"},{name:"dataset_num_proc",val:": Optional = None"}],parametersDescription:[{anchor:"trl.ORPOConfig.max_length",description:`<strong>max_length</strong> (<code>int</code>, defaults to <code>None</code>) &#x2014;
The maximum length of the sequences in the batch. This argument is required if you want to use the default data collator.`,name:"max_length"},{anchor:"trl.ORPOConfig.max_prompt_length",description:`<strong>max_prompt_length</strong> (<code>int</code>, defaults to <code>None</code>) &#x2014;
The maximum length of the prompt. This argument is required if you want to use the default data collator.`,name:"max_prompt_length"},{anchor:"trl.ORPOConfig.max_completion_length",description:`<strong>max_completion_length</strong> (<code>int</code>, defaults to <code>None</code>) &#x2014;
The maximum length of the completions. This argument is required if you want to use the default data collator and your model is an encoder-decoder.`,name:"max_completion_length"},{anchor:"trl.ORPOConfig.beta",description:`<strong>beta</strong> (<code>float</code>, defaults to 0.1) &#x2014;
The beta factor in ORPO loss (lambda/alpha in paper/code) that is the weight of the relative loss ratio in the SFT loss.`,name:"beta"},{anchor:"trl.ORPOConfig.label_pad_token_id",description:`<strong>label_pad_token_id</strong> (<code>int</code>, defaults to <code>-100</code>) &#x2014;
The label pad token id. This argument is required if you want to use the default data collator.`,name:"label_pad_token_id"},{anchor:"trl.ORPOConfig.padding_value",description:`<strong>padding_value</strong> (<code>int</code>, defaults to <code>None</code>) &#x2014;
The padding value if it is different to the tokenizer&#x2019;s pad_token_id.`,name:"padding_value"},{anchor:"trl.ORPOConfig.truncation_mode",description:`<strong>truncation_mode</strong> (<code>str</code>, defaults to <code>keep_end</code>) &#x2014;
The truncation mode to use, either <code>keep_end</code> or <code>keep_start</code>. This argument is required if you want to use the default data collator.`,name:"truncation_mode"},{anchor:"trl.ORPOConfig.generate_during_eval",description:`<strong>generate_during_eval</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to sample and log generations during evaluation step.`,name:"generate_during_eval"},{anchor:"trl.ORPOConfig.is_encoder_decoder",description:`<strong>is_encoder_decoder</strong> (<code>Optional[bool]</code>, <code>optional</code>, defaults to <code>None</code>) &#x2014;
If no model is provided, we need to know if the model_init returns an encoder-decoder.`,name:"is_encoder_decoder"},{anchor:"trl.ORPOConfig.disable_dropout",description:`<strong>disable_dropout</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether or not to disable dropouts in <code>model</code>.`,name:"disable_dropout"},{anchor:"trl.ORPOConfig.model_init_kwargs",description:`<strong>model_init_kwargs</strong> (<code>Optional[Dict]</code>, <em>optional</em>) &#x2014;
Dict of Optional kwargs to pass when instantiating the model from a string`,name:"model_init_kwargs"},{anchor:"trl.ORPOConfig.dataset_num_proc",description:`<strong>dataset_num_proc</strong> (<code>Optional[int]</code>, <em>optional</em>) &#x2014;
The number of workers to use to tokenize the data. Defaults to None.`,name:"dataset_num_proc"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/orpo_config.py#L20"}}),ra=new D({props:{title:"ORPOTrainer",local:"trl.ORPOTrainer",headingTag:"h2"}}),la=new f({props:{name:"class trl.ORPOTrainer",anchor:"trl.ORPOTrainer",parameters:[{name:"model",val:": Union = None"},{name:"args",val:": Optional = None"},{name:"data_collator",val:": Optional = None"},{name:"train_dataset",val:": Optional = None"},{name:"eval_dataset",val:": Union = None"},{name:"tokenizer",val:": Optional = None"},{name:"model_init",val:": Optional = None"},{name:"callbacks",val:": Optional = None"},{name:"optimizers",val:": Tuple = (None, None)"},{name:"preprocess_logits_for_metrics",val:": Optional = None"},{name:"peft_config",val:": Optional = None"},{name:"compute_metrics",val:": Optional = None"}],parametersDescription:[{anchor:"trl.ORPOTrainer.model",description:`<strong>model</strong> (<code>transformers.PreTrainedModel</code>) &#x2014;
The model to train, preferably an <code>AutoModelForSequenceClassification</code>.`,name:"model"},{anchor:"trl.ORPOTrainer.args",description:`<strong>args</strong> (<code>ORPOConfig</code>) &#x2014;
The ORPO config arguments to use for training.`,name:"args"},{anchor:"trl.ORPOTrainer.data_collator",description:`<strong>data_collator</strong> (<code>transformers.DataCollator</code>) &#x2014;
The data collator to use for training. If None is specified, the default data collator (<code>DPODataCollatorWithPadding</code>) will be used
which will pad the sequences to the maximum length of the sequences in the batch, given a dataset of paired sequences.`,name:"data_collator"},{anchor:"trl.ORPOTrainer.train_dataset",description:`<strong>train_dataset</strong> (<code>datasets.Dataset</code>) &#x2014;
The dataset to use for training.`,name:"train_dataset"},{anchor:"trl.ORPOTrainer.eval_dataset",description:`<strong>eval_dataset</strong> (<code>datasets.Dataset</code>) &#x2014;
The dataset to use for evaluation.`,name:"eval_dataset"},{anchor:"trl.ORPOTrainer.tokenizer",description:`<strong>tokenizer</strong> (<code>transformers.PreTrainedTokenizerBase</code>) &#x2014;
The tokenizer to use for training. This argument is required if you want to use the default data collator.`,name:"tokenizer"},{anchor:"trl.ORPOTrainer.model_init",description:`<strong>model_init</strong> (<code>Callable[[], transformers.PreTrainedModel]</code>) &#x2014;
The model initializer to use for training. If None is specified, the default model initializer will be used.`,name:"model_init"},{anchor:"trl.ORPOTrainer.callbacks",description:`<strong>callbacks</strong> (<code>List[transformers.TrainerCallback]</code>) &#x2014;
The callbacks to use for training.`,name:"callbacks"},{anchor:"trl.ORPOTrainer.optimizers",description:`<strong>optimizers</strong> (<code>Tuple[torch.optim.Optimizer, torch.optim.lr_scheduler.LambdaLR]</code>) &#x2014;
The optimizer and scheduler to use for training.`,name:"optimizers"},{anchor:"trl.ORPOTrainer.preprocess_logits_for_metrics",description:`<strong>preprocess_logits_for_metrics</strong> (<code>Callable[[torch.Tensor, torch.Tensor], torch.Tensor]</code>) &#x2014;
The function to use to preprocess the logits before computing the metrics.`,name:"preprocess_logits_for_metrics"},{anchor:"trl.ORPOTrainer.peft_config",description:`<strong>peft_config</strong> (<code>Dict</code>, defaults to <code>None</code>) &#x2014;
The PEFT configuration to use for training. If you pass a PEFT configuration, the model will be wrapped in a PEFT model.`,name:"peft_config"},{anchor:"trl.ORPOTrainer.compute_metrics",description:`<strong>compute_metrics</strong> (<code>Callable[[EvalPrediction], Dict]</code>, <em>optional</em>) &#x2014;
The function to use to compute the metrics. Must take a <code>EvalPrediction</code> and return
a dictionary string to metric values.`,name:"compute_metrics"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/orpo_trainer.py#L62"}}),ia=new f({props:{name:"build_tokenized_answer",anchor:"trl.ORPOTrainer.build_tokenized_answer",parameters:[{name:"prompt",val:""},{name:"answer",val:""}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/orpo_trainer.py#L334"}}),sa=new f({props:{name:"concatenated_forward",anchor:"trl.ORPOTrainer.concatenated_forward",parameters:[{name:"model",val:": Module"},{name:"batch",val:": Dict"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/orpo_trainer.py#L662"}}),da=new f({props:{name:"concatenated_inputs",anchor:"trl.ORPOTrainer.concatenated_inputs",parameters:[{name:"batch",val:": Dict"},{name:"is_encoder_decoder",val:": bool = False"},{name:"label_pad_token_id",val:": int = -100"},{name:"padding_value",val:": int = 0"},{name:"device",val:": Optional = None"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/orpo_trainer.py#L530",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A dictionary containing the concatenated inputs under the key ‘concatenated_input_ids’.</p>
`}}),ca=new f({props:{name:"evaluation_loop",anchor:"trl.ORPOTrainer.evaluation_loop",parameters:[{name:"dataloader",val:": DataLoader"},{name:"description",val:": str"},{name:"prediction_loss_only",val:": Optional = None"},{name:"ignore_keys",val:": Optional = None"},{name:"metric_key_prefix",val:": str = 'eval'"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/orpo_trainer.py#L860"}}),ma=new f({props:{name:"get_batch_logps",anchor:"trl.ORPOTrainer.get_batch_logps",parameters:[{name:"logits",val:": FloatTensor"},{name:"labels",val:": LongTensor"},{name:"average_log_prob",val:": bool = False"},{name:"label_pad_token_id",val:": int = -100"},{name:"is_encoder_decoder",val:": bool = False"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/orpo_trainer.py#L624",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A tensor of shape (batch_size,) containing the average/sum log probabilities of the given labels under the given logits.</p>
`}}),pa=new f({props:{name:"get_batch_loss_metrics",anchor:"trl.ORPOTrainer.get_batch_loss_metrics",parameters:[{name:"model",val:""},{name:"batch",val:": Dict"},{name:"train_eval",val:": Literal = 'train'"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/orpo_trainer.py#L731"}}),ga=new f({props:{name:"get_batch_samples",anchor:"trl.ORPOTrainer.get_batch_samples",parameters:[{name:"model",val:""},{name:"batch",val:": Dict"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/orpo_trainer.py#L795"}}),_a=new f({props:{name:"log",anchor:"trl.ORPOTrainer.log",parameters:[{name:"logs",val:": Dict"}],parametersDescription:[{anchor:"trl.ORPOTrainer.log.logs",description:`<strong>logs</strong> (<code>Dict[str, float]</code>) &#x2014;
The values to log.`,name:"logs"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/orpo_trainer.py#L908"}}),ha=new f({props:{name:"odds_ratio_loss",anchor:"trl.ORPOTrainer.odds_ratio_loss",parameters:[{name:"policy_chosen_logps",val:": FloatTensor"},{name:"policy_rejected_logps",val:": FloatTensor"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/orpo_trainer.py#L592",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>(losses, chosen_rewards, rejected_rewards).
The losses tensor contains the ORPO loss for each example in the batch.
The chosen_rewards and rejected_rewards tensors contain the rewards for the chosen and rejected responses, respectively.
The log odds ratio of the chosen responses over the rejected responses ratio for logging purposes.
The <code>log(sigmoid(log_odds_chosen))</code> for logging purposes.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A tuple of three tensors</p>
`}}),ua=new f({props:{name:"tokenize_row",anchor:"trl.ORPOTrainer.tokenize_row",parameters:[{name:"feature",val:""},{name:"model",val:": Union = None"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/orpo_trainer.py#L384"}}),fa=new D({props:{title:"PPOConfig",local:"trl.PPOConfig",headingTag:"h2"}}),va=new f({props:{name:"class trl.PPOConfig",anchor:"trl.PPOConfig",parameters:[{name:"exp_name",val:": str = 'doc-buil'"},{name:"seed",val:": int = 0"},{name:"log_with",val:": Optional = None"},{name:"task_name",val:": Optional = None"},{name:"model_name",val:": Optional = 'gpt2'"},{name:"query_dataset",val:": Optional = 'imdb'"},{name:"reward_model",val:": Optional = 'sentiment-analysis:lvwerra/distilbert-imdb'"},{name:"remove_unused_columns",val:": bool = True"},{name:"tracker_kwargs",val:": Annotated = <factory>"},{name:"accelerator_kwargs",val:": Annotated = <factory>"},{name:"project_kwargs",val:": Annotated = <factory>"},{name:"tracker_project_name",val:": str = 'trl'"},{name:"push_to_hub_if_best_kwargs",val:": Annotated = <factory>"},{name:"steps",val:": int = 20000"},{name:"learning_rate",val:": float = 1.41e-05"},{name:"adap_kl_ctrl",val:": bool = True"},{name:"init_kl_coef",val:": Optional = 0.2"},{name:"kl_penalty",val:": Literal = 'kl'"},{name:"target",val:": Optional = 6"},{name:"horizon",val:": Optional = 10000"},{name:"gamma",val:": float = 1"},{name:"lam",val:": float = 0.95"},{name:"cliprange",val:": float = 0.2"},{name:"cliprange_value",val:": float = 0.2"},{name:"vf_coef",val:": float = 0.1"},{name:"batch_size",val:": int = 128"},{name:"forward_batch_size",val:": Optional = None"},{name:"mini_batch_size",val:": int = 128"},{name:"gradient_accumulation_steps",val:": int = 1"},{name:"world_size",val:": Annotated = None"},{name:"ppo_epochs",val:": int = 4"},{name:"max_grad_norm",val:": Optional = None"},{name:"optimize_cuda_cache",val:": Optional = None"},{name:"optimize_device_cache",val:": Optional = False"},{name:"early_stopping",val:": bool = False"},{name:"target_kl",val:": float = 1"},{name:"compare_steps",val:": int = 1"},{name:"ratio_threshold",val:": float = 10.0"},{name:"use_score_scaling",val:": bool = False"},{name:"use_score_norm",val:": bool = False"},{name:"score_clip",val:": Optional = None"},{name:"whiten_rewards",val:": bool = False"},{name:"is_encoder_decoder",val:": Optional = None"},{name:"is_peft_model",val:": Optional = None"},{name:"backward_batch_size",val:": Annotated = None"},{name:"global_backward_batch_size",val:": Annotated = None"},{name:"global_batch_size",val:": Annotated = None"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_config.py#L34"}}),ba=new D({props:{title:"PPOTrainer",local:"trl.PPOTrainer",headingTag:"h2"}}),Ta=new f({props:{name:"class trl.PPOTrainer",anchor:"trl.PPOTrainer",parameters:[{name:"config",val:": Optional = None"},{name:"model",val:": Optional = None"},{name:"ref_model",val:": Optional = None"},{name:"tokenizer",val:": Optional = None"},{name:"dataset",val:": Union = None"},{name:"optimizer",val:": Optional = None"},{name:"data_collator",val:": Optional = None"},{name:"num_shared_layers",val:": Optional = None"},{name:"lr_scheduler",val:": Optional = None"}],parametersDescription:[{anchor:"trl.PPOTrainer.*config**",description:`*<strong>*config**</strong> (<code>PPOConfig</code>) &#x2014; Configuration object for PPOTrainer. Check the documentation of <code>PPOConfig</code> for more &#x2014;
details.`,name:"*config**"},{anchor:"trl.PPOTrainer.*model**",description:`*<strong>*model**</strong> (<code>PreTrainedModelWrapper</code>) &#x2014; Model to be optimized, Hugging Face transformer model with a value head. &#x2014;
Check the documentation of <code>PreTrainedModelWrapper</code> for more details.`,name:"*model**"},{anchor:"trl.PPOTrainer.*ref_model**",description:`*<strong>*ref_model**</strong> (<code>PreTrainedModelWrapper</code>, <em>optional</em>) &#x2014; Reference model to be used for KL penalty, Hugging Face &#x2014;
transformer model with a casual language modelling head. Check the documentation of <code>PreTrainedModelWrapper</code>
for more details. If no reference model is provided, the trainer will create a reference model with the same
architecture as the model to be optimized with shared layers.`,name:"*ref_model**"},{anchor:"trl.PPOTrainer.*tokenizer**",description:`*<strong>*tokenizer**</strong> (<code>PreTrainedTokenizerBase</code>) &#x2014; Tokenizer to be used for encoding the &#x2014;
data. Check the documentation of <code>transformers.PreTrainedTokenizer</code> and
<code>transformers.PreTrainedTokenizerFast</code> for more details.`,name:"*tokenizer**"},{anchor:"trl.PPOTrainer.*dataset**",description:`*<strong>*dataset**</strong> (Union[<code>torch.utils.data.Dataset</code>, <code>datasets.Dataset</code>], <em>optional</em>) &#x2014; PyTorch dataset or Hugging &#x2014;
Face dataset. This is used to create a PyTorch dataloader. If no dataset is provided, the dataloader must be
created outside the trainer users needs to design their own dataloader and make sure the batch
size that is used is the same as the one specified in the configuration object.`,name:"*dataset**"},{anchor:"trl.PPOTrainer.*optimizer**",description:`*<strong>*optimizer**</strong> (<code>torch.optim.Optimizer</code>, <em>optional</em>) &#x2014; Optimizer to be used for training. If no optimizer is &#x2014;
provided, the trainer will create an Adam optimizer with the learning rate specified in the configuration
object.`,name:"*optimizer**"},{anchor:"trl.PPOTrainer.*data_collator**",description:`*<strong>*data_collator**</strong> (DataCollatorForLanguageModeling, <em>optional</em>) &#x2014; Data collator to be used for training and &#x2014;
passed along the dataloader`,name:"*data_collator**"},{anchor:"trl.PPOTrainer.*num_shared_layers**",description:`*<strong>*num_shared_layers**</strong> (int, <em>optional</em>) &#x2014; Number of layers to be shared between the model and the reference &#x2014;
model, if no reference model is passed. If no number is provided, all the layers will be shared.`,name:"*num_shared_layers**"},{anchor:"trl.PPOTrainer.*lr_scheduler**",description:"*<strong>*lr_scheduler**</strong> (<code>torch.optim.lr_scheduler</code>, <em>optional</em>) &#x2014; Learning rate scheduler to be used for training. &#x2014;",name:"*lr_scheduler**"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L114"}}),Oa=new f({props:{name:"batched_forward_pass",anchor:"trl.PPOTrainer.batched_forward_pass",parameters:[{name:"model",val:": PreTrainedModelWrapper"},{name:"queries",val:": Tensor"},{name:"responses",val:": Tensor"},{name:"model_inputs",val:": dict"},{name:"return_logits",val:": bool = False"},{name:"response_masks",val:": Optional = None"}],parametersDescription:[{anchor:"trl.PPOTrainer.batched_forward_pass.queries",description:`<strong>queries</strong> (<code>torch.LongTensor</code>) &#x2014;
List of tensors containing the encoded queries, shape (<code>batch_size</code>, <code>query_length</code>)`,name:"queries"},{anchor:"trl.PPOTrainer.batched_forward_pass.responses",description:`<strong>responses</strong> (<code>torch.LongTensor</code>) &#x2014;
List of tensors containing the encoded responses, shape (<code>batch_size</code>, <code>response_length</code>)`,name:"responses"},{anchor:"trl.PPOTrainer.batched_forward_pass.return_logits",description:`<strong>return_logits</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to return all_logits. Set to <code>False</code> if logits are not needed to reduce memory consumption.`,name:"return_logits"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L951",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<ul>
<li>all_logprobs (<code>torch.FloatTensor</code>): Log probabilities of the responses,
shape (<code>batch_size</code>, <code>response_length</code>)</li>
<li>all_ref_logprobs (<code>torch.FloatTensor</code>): Log probabilities of the responses,
shape (<code>batch_size</code>, <code>response_length</code>)</li>
<li>all_values (<code>torch.FloatTensor</code>): Values of the responses, shape (<code>batch_size</code>, <code>response_length</code>)</li>
</ul>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p>(tuple)</p>
`}}),xa=new f({props:{name:"compute_rewards",anchor:"trl.PPOTrainer.compute_rewards",parameters:[{name:"scores",val:": FloatTensor"},{name:"logprobs",val:": FloatTensor"},{name:"ref_logprobs",val:": FloatTensor"},{name:"masks",val:": LongTensor"}],parametersDescription:[{anchor:"trl.PPOTrainer.compute_rewards.scores",description:`<strong>scores</strong> (<code>torch.FloatTensor</code>) &#x2014;
Scores from the reward model, shape (<code>batch_size</code>)`,name:"scores"},{anchor:"trl.PPOTrainer.compute_rewards.logprobs",description:`<strong>logprobs</strong> (<code>torch.FloatTensor</code>) &#x2014;
Log probabilities of the model, shape (<code>batch_size</code>, <code>response_length</code>)`,name:"logprobs"},{anchor:"trl.PPOTrainer.compute_rewards.ref_logprobs",description:`<strong>ref_logprobs</strong> (<code>torch.FloatTensor</code>) &#x2014;
Log probabilities of the reference model, shape (<code>batch_size</code>, <code>response_length</code>)`,name:"ref_logprobs"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L1088",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>Per token rewards, shape (<code>batch_size</code>, <code>response_length</code>)
<code>torch.FloatTensor</code>: Non score rewards, shape (<code>batch_size</code>, <code>response_length</code>)
<code>torch.FloatTensor</code>: KL penalty, shape (<code>batch_size</code>, <code>response_length</code>)</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.FloatTensor</code></p>
`}}),$a=new f({props:{name:"create_model_card",anchor:"trl.PPOTrainer.create_model_card",parameters:[{name:"path",val:": str"},{name:"model_name",val:": Optional = 'TRL Model'"}],parametersDescription:[{anchor:"trl.PPOTrainer.create_model_card.path",description:"<strong>path</strong> (<code>str</code>) &#x2014; The path to save the model card to.",name:"path"},{anchor:"trl.PPOTrainer.create_model_card.model_name",description:"<strong>model_name</strong> (<code>str</code>, <em>optional</em>) &#x2014; The name of the model, defaults to <code>TRL Model</code>.",name:"model_name"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L1396"}}),Pa=new f({props:{name:"gather_stats",anchor:"trl.PPOTrainer.gather_stats",parameters:[{name:"stats",val:""}],parametersDescription:[{anchor:"trl.PPOTrainer.gather_stats.stats",description:"<strong>stats</strong> (dict[str, Any]) &#x2014;",name:"stats"},{anchor:"trl.PPOTrainer.gather_stats.a",description:"<strong>a</strong> dictionary of stats to be gathered. The stats should contain torch tensors. &#x2014;",name:"a"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L907",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A dictionary of stats with the tensors gathered.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>dict[str, Any]</code></p>
`}}),wa=new f({props:{name:"generate",anchor:"trl.PPOTrainer.generate",parameters:[{name:"query_tensor",val:": Union"},{name:"length_sampler",val:": Optional = None"},{name:"batch_size",val:": int = 4"},{name:"return_prompt",val:": bool = True"},{name:"generate_ref_response",val:": bool = False"},{name:"**generation_kwargs",val:""}],parametersDescription:[{anchor:"trl.PPOTrainer.generate.query_tensor",description:`<strong>query_tensor</strong> (<code>torch.LongTensor</code>) &#x2014;
A tensor of shape (<code>seq_len</code>) containing query tokens or a list of tensors of shape (<code>seq_len</code>).`,name:"query_tensor"},{anchor:"trl.PPOTrainer.generate.length_sampler",description:`<strong>length_sampler</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
Callable that returns the number of newly generated tokens.`,name:"length_sampler"},{anchor:"trl.PPOTrainer.generate.batch_size",description:`<strong>batch_size</strong> (<code>int</code>, *optional) &#x2014;
Batch size used for generation, defaults to <code>4</code>.`,name:"batch_size"},{anchor:"trl.PPOTrainer.generate.return_prompt",description:`<strong>return_prompt</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>False</code> the prompt is not returned but only the newly generated tokens, defaults to <code>True</code>.`,name:"return_prompt"},{anchor:"trl.PPOTrainer.generate.generate_ref_response",description:`<strong>generate_ref_response</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>True</code> the reference response is also generated, defaults to <code>False</code>.`,name:"generate_ref_response"},{anchor:"trl.PPOTrainer.generate.generation_kwargs",description:`<strong>generation_kwargs</strong> (dict[str, Any]) &#x2014;
Keyword arguments for generation.`,name:"generation_kwargs"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L436",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A tensor of shape (<code>batch_size</code>, <code>gen_len</code>) containing response tokens.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.LongTensor</code></p>
`}}),ya=new f({props:{name:"log_stats",anchor:"trl.PPOTrainer.log_stats",parameters:[{name:"stats",val:": dict"},{name:"batch",val:": dict"},{name:"rewards",val:": List"},{name:"columns_to_log",val:": Iterable = ('query', 'response')"}],parametersDescription:[{anchor:"trl.PPOTrainer.log_stats.stats",description:`<strong>stats</strong> (dict[str, Any]) &#x2014;
A dictionary of training stats.`,name:"stats"},{anchor:"trl.PPOTrainer.log_stats.batch",description:`<strong>batch</strong> (dict[str, Any]) &#x2014;
A dictionary of batch data, this contains the queries and responses.`,name:"batch"},{anchor:"trl.PPOTrainer.log_stats.rewards",description:`<strong>rewards</strong> (<code>List[torch.FloatTensor]</code>) &#x2014;
A tensor of rewards.`,name:"rewards"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L1323"}}),Ca=new f({props:{name:"loss",anchor:"trl.PPOTrainer.loss",parameters:[{name:"old_logprobs",val:": FloatTensor"},{name:"values",val:": FloatTensor"},{name:"logits",val:": FloatTensor"},{name:"vpreds",val:": FloatTensor"},{name:"logprobs",val:": FloatTensor"},{name:"mask",val:": LongTensor"},{name:"advantages",val:": FloatTensor"},{name:"returns",val:": FloatTensor"}],parametersDescription:[{anchor:"trl.PPOTrainer.loss.old_logprobs",description:`<strong>old_logprobs</strong> (<code>torch.FloatTensor</code>) &#x2014;
Log probabilities of the model, shape (<code>batch_size</code>, <code>response_length</code>)`,name:"old_logprobs"},{anchor:"trl.PPOTrainer.loss.values",description:`<strong>values</strong> (<code>torch.FloatTensor</code>) &#x2014;
Values of the value head, shape (<code>batch_size</code>, <code>response_length</code>)`,name:"values"},{anchor:"trl.PPOTrainer.loss.rewards",description:`<strong>rewards</strong> (<code>torch.FloatTensor</code>) &#x2014;
Rewards from the reward model, shape (<code>batch_size</code>, <code>response_length</code>)`,name:"rewards"},{anchor:"trl.PPOTrainer.loss.logits",description:`<strong>logits</strong> (<code>torch.FloatTensor</code>) &#x2014;
Logits of the model, shape (<code>batch_size</code>, <code>response_length</code>, <code>vocab_size</code>)`,name:"logits"},{anchor:"trl.PPOTrainer.loss.v_pred",description:`<strong>v_pred</strong> (<code>torch.FloatTensor</code>) &#x2014;
Values of the value head, shape (<code>batch_size</code>, <code>response_length</code>)`,name:"v_pred"},{anchor:"trl.PPOTrainer.loss.logprobs",description:`<strong>logprobs</strong> (<code>torch.FloatTensor</code>) &#x2014;
Log probabilities of the model, shape (<code>batch_size</code>, <code>response_length</code>)`,name:"logprobs"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L1170"}}),ka=new f({props:{name:"prepare_dataloader",anchor:"trl.PPOTrainer.prepare_dataloader",parameters:[{name:"dataset",val:": Union"},{name:"data_collator",val:" = None"}],parametersDescription:[{anchor:"trl.PPOTrainer.prepare_dataloader.dataset",description:`<strong>dataset</strong> (Union[<code>torch.utils.data.Dataset</code>, <code>datasets.Dataset</code>]) &#x2014;
PyTorch dataset or Hugging Face dataset. If a Hugging Face dataset is passed, the dataset
will be preprocessed by removing the columns that are not used by the model.`,name:"dataset"},{anchor:"trl.PPOTrainer.prepare_dataloader.data_collator",description:`<strong>data_collator</strong> (Optional[function]) &#x2014;
Data collator function.`,name:"data_collator"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L381",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>PyTorch dataloader</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.utils.data.DataLoader</code></p>
`}}),Na=new f({props:{name:"record_step_stats",anchor:"trl.PPOTrainer.record_step_stats",parameters:[{name:"kl_coef",val:": float"},{name:"**data",val:""}],parametersDescription:[{anchor:"trl.PPOTrainer.record_step_stats.kl_coef",description:`<strong>kl_coef</strong> (<code>float</code>) &#x2014;
KL coefficient`,name:"kl_coef"},{anchor:"trl.PPOTrainer.record_step_stats.data",description:`<strong>data</strong> (<code>dict</code>) &#x2014;
Dictionary of training step data`,name:"data"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L1259",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>Dictionary of training step statistics</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p>stats (<code>dict</code>)</p>
`}}),Da=new f({props:{name:"step",anchor:"trl.PPOTrainer.step",parameters:[{name:"queries",val:": List"},{name:"responses",val:": List"},{name:"scores",val:": List"},{name:"response_masks",val:": Optional = None"}],parametersDescription:[{anchor:"trl.PPOTrainer.step.queries",description:`<strong>queries</strong> (List<code>torch.LongTensor</code>) &#x2014;
List of tensors containing the encoded queries of shape (<code>query_length</code>)`,name:"queries"},{anchor:"trl.PPOTrainer.step.responses",description:`<strong>responses</strong> (List<code>torch.LongTensor</code>) &#x2014;
List of tensors containing the encoded responses of shape (<code>response_length</code>)`,name:"responses"},{anchor:"trl.PPOTrainer.step.scores",description:`<strong>scores</strong> (List<code>torch.FloatTensor</code>) &#x2014;
List of tensors containing the scores.`,name:"scores"},{anchor:"trl.PPOTrainer.step.response_masks",description:`<strong>response_masks</strong> (List<code>torch.FloatTensor</code>, <em>optional</em>)) &#x2014;
List of tensors containing masks of the response tokens.`,name:"response_masks"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L627",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A summary of the training statistics</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>dict[str, Any]</code></p>
`}}),Fa=new f({props:{name:"train_minibatch",anchor:"trl.PPOTrainer.train_minibatch",parameters:[{name:"old_logprobs",val:": FloatTensor"},{name:"values",val:": FloatTensor"},{name:"logprobs",val:": FloatTensor"},{name:"logits",val:": FloatTensor"},{name:"vpreds",val:": FloatTensor"},{name:"mask",val:": LongTensor"},{name:"advantages",val:": FloatTensor"},{name:"returns",val:": FloatTensor"}],parametersDescription:[{anchor:"trl.PPOTrainer.train_minibatch.logprobs",description:`<strong>logprobs</strong> (<code>torch.FloatTensor</code>) &#x2014;
Log probabilities of the model, shape [mini_batch_size, response_length]`,name:"logprobs"},{anchor:"trl.PPOTrainer.train_minibatch.values",description:`<strong>values</strong> (<code>torch.FloatTensor</code>) &#x2014;
Values of the value head, shape [mini_batch_size, response_length]`,name:"values"},{anchor:"trl.PPOTrainer.train_minibatch.query",description:`<strong>query</strong> (<code>torch.LongTensor</code>) &#x2014;
Encoded queries, shape [mini_batch_size, query_length]`,name:"query"},{anchor:"trl.PPOTrainer.train_minibatch.response",description:`<strong>response</strong> (<code>torch.LongTensor</code>) &#x2014;
Encoded responses, shape [mini_batch_size, response_length]`,name:"response"},{anchor:"trl.PPOTrainer.train_minibatch.model_input",description:`<strong>model_input</strong> (<code>torch.LongTensor</code>) &#x2014;
Concatenated queries and responses, shape [mini_batch_size, query_length+response_length]`,name:"model_input"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L1042",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>Dictionary of training statistics</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p>train_stats (dict[str, <code>torch.Tensor</code>])</p>
`}}),La=new D({props:{title:"RewardConfig",local:"trl.RewardConfig",headingTag:"h2"}}),za=new f({props:{name:"class trl.RewardConfig",anchor:"trl.RewardConfig",parameters:[{name:"output_dir",val:": str"},{name:"overwrite_output_dir",val:": bool = False"},{name:"do_train",val:": bool = False"},{name:"do_eval",val:": bool = False"},{name:"do_predict",val:": bool = False"},{name:"eval_strategy",val:": Union = 'no'"},{name:"prediction_loss_only",val:": bool = False"},{name:"per_device_train_batch_size",val:": int = 8"},{name:"per_device_eval_batch_size",val:": int = 8"},{name:"per_gpu_train_batch_size",val:": Optional = None"},{name:"per_gpu_eval_batch_size",val:": Optional = None"},{name:"gradient_accumulation_steps",val:": int = 1"},{name:"eval_accumulation_steps",val:": Optional = None"},{name:"eval_delay",val:": Optional = 0"},{name:"learning_rate",val:": float = 5e-05"},{name:"weight_decay",val:": float = 0.0"},{name:"adam_beta1",val:": float = 0.9"},{name:"adam_beta2",val:": float = 0.999"},{name:"adam_epsilon",val:": float = 1e-08"},{name:"max_grad_norm",val:": float = 1.0"},{name:"num_train_epochs",val:": float = 3.0"},{name:"max_steps",val:": int = -1"},{name:"lr_scheduler_type",val:": Union = 'linear'"},{name:"lr_scheduler_kwargs",val:": Union = <factory>"},{name:"warmup_ratio",val:": float = 0.0"},{name:"warmup_steps",val:": int = 0"},{name:"log_level",val:": Optional = 'passive'"},{name:"log_level_replica",val:": Optional = 'warning'"},{name:"log_on_each_node",val:": bool = True"},{name:"logging_dir",val:": Optional = None"},{name:"logging_strategy",val:": Union = 'steps'"},{name:"logging_first_step",val:": bool = False"},{name:"logging_steps",val:": float = 500"},{name:"logging_nan_inf_filter",val:": bool = True"},{name:"save_strategy",val:": Union = 'steps'"},{name:"save_steps",val:": float = 500"},{name:"save_total_limit",val:": Optional = None"},{name:"save_safetensors",val:": Optional = True"},{name:"save_on_each_node",val:": bool = False"},{name:"save_only_model",val:": bool = False"},{name:"no_cuda",val:": bool = False"},{name:"use_cpu",val:": bool = False"},{name:"use_mps_device",val:": bool = False"},{name:"seed",val:": int = 42"},{name:"data_seed",val:": Optional = None"},{name:"jit_mode_eval",val:": bool = False"},{name:"use_ipex",val:": bool = False"},{name:"bf16",val:": bool = False"},{name:"fp16",val:": bool = False"},{name:"fp16_opt_level",val:": str = 'O1'"},{name:"half_precision_backend",val:": str = 'auto'"},{name:"bf16_full_eval",val:": bool = False"},{name:"fp16_full_eval",val:": bool = False"},{name:"tf32",val:": Optional = None"},{name:"local_rank",val:": int = -1"},{name:"ddp_backend",val:": Optional = None"},{name:"tpu_num_cores",val:": Optional = None"},{name:"tpu_metrics_debug",val:": bool = False"},{name:"debug",val:": Union = ''"},{name:"dataloader_drop_last",val:": bool = False"},{name:"eval_steps",val:": Optional = None"},{name:"dataloader_num_workers",val:": int = 0"},{name:"dataloader_prefetch_factor",val:": Optional = None"},{name:"past_index",val:": int = -1"},{name:"run_name",val:": Optional = None"},{name:"disable_tqdm",val:": Optional = None"},{name:"remove_unused_columns",val:": Optional = True"},{name:"label_names",val:": Optional = None"},{name:"load_best_model_at_end",val:": Optional = False"},{name:"metric_for_best_model",val:": Optional = None"},{name:"greater_is_better",val:": Optional = None"},{name:"ignore_data_skip",val:": bool = False"},{name:"fsdp",val:": Union = ''"},{name:"fsdp_min_num_params",val:": int = 0"},{name:"fsdp_config",val:": Union = None"},{name:"fsdp_transformer_layer_cls_to_wrap",val:": Optional = None"},{name:"accelerator_config",val:": Union = None"},{name:"deepspeed",val:": Union = None"},{name:"label_smoothing_factor",val:": float = 0.0"},{name:"optim",val:": Union = 'adamw_torch'"},{name:"optim_args",val:": Optional = None"},{name:"adafactor",val:": bool = False"},{name:"group_by_length",val:": bool = False"},{name:"length_column_name",val:": Optional = 'length'"},{name:"report_to",val:": Union = None"},{name:"ddp_find_unused_parameters",val:": Optional = None"},{name:"ddp_bucket_cap_mb",val:": Optional = None"},{name:"ddp_broadcast_buffers",val:": Optional = None"},{name:"dataloader_pin_memory",val:": bool = True"},{name:"dataloader_persistent_workers",val:": bool = False"},{name:"skip_memory_metrics",val:": bool = True"},{name:"use_legacy_prediction_loop",val:": bool = False"},{name:"push_to_hub",val:": bool = False"},{name:"resume_from_checkpoint",val:": Optional = None"},{name:"hub_model_id",val:": Optional = None"},{name:"hub_strategy",val:": Union = 'every_save'"},{name:"hub_token",val:": Optional = None"},{name:"hub_private_repo",val:": bool = False"},{name:"hub_always_push",val:": bool = False"},{name:"gradient_checkpointing",val:": bool = False"},{name:"gradient_checkpointing_kwargs",val:": Union = None"},{name:"include_inputs_for_metrics",val:": bool = False"},{name:"eval_do_concat_batches",val:": bool = True"},{name:"fp16_backend",val:": str = 'auto'"},{name:"evaluation_strategy",val:": Union = None"},{name:"push_to_hub_model_id",val:": Optional = None"},{name:"push_to_hub_organization",val:": Optional = None"},{name:"push_to_hub_token",val:": Optional = None"},{name:"mp_parameters",val:": str = ''"},{name:"auto_find_batch_size",val:": bool = False"},{name:"full_determinism",val:": bool = False"},{name:"torchdynamo",val:": Optional = None"},{name:"ray_scope",val:": Optional = 'last'"},{name:"ddp_timeout",val:": Optional = 1800"},{name:"torch_compile",val:": bool = False"},{name:"torch_compile_backend",val:": Optional = None"},{name:"torch_compile_mode",val:": Optional = None"},{name:"dispatch_batches",val:": Optional = None"},{name:"split_batches",val:": Optional = None"},{name:"include_tokens_per_second",val:": Optional = False"},{name:"include_num_input_tokens_seen",val:": Optional = False"},{name:"neftune_noise_alpha",val:": Optional = None"},{name:"optim_target_modules",val:": Union = None"},{name:"max_length",val:": Optional = None"}],parametersDescription:[{anchor:"trl.RewardConfig.max_length",description:`<strong>max_length</strong> (<code>int</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
The maximum length of the sequences in the batch. This argument is required if you want to use the default data collator.`,name:"max_length"},{anchor:"trl.RewardConfig.gradient_checkpointing",description:`<strong>gradient_checkpointing</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
If True, use gradient checkpointing to save memory at the expense of slower backward pass.`,name:"gradient_checkpointing"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/reward_config.py#L21"}}),Ia=new D({props:{title:"RewardTrainer",local:"trl.RewardTrainer",headingTag:"h2"}}),Ma=new f({props:{name:"class trl.RewardTrainer",anchor:"trl.RewardTrainer",parameters:[{name:"model",val:": Union = None"},{name:"args",val:": Optional = None"},{name:"data_collator",val:": Optional = None"},{name:"train_dataset",val:": Optional = None"},{name:"eval_dataset",val:": Union = None"},{name:"tokenizer",val:": Optional = None"},{name:"model_init",val:": Optional = None"},{name:"compute_metrics",val:": Optional = None"},{name:"callbacks",val:": Optional = None"},{name:"optimizers",val:": Tuple = (None, None)"},{name:"preprocess_logits_for_metrics",val:": Optional = None"},{name:"max_length",val:": Optional = None"},{name:"peft_config",val:": Optional = None"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/reward_trainer.py#L36"}}),qa=new D({props:{title:"SFTTrainer",local:"trl.SFTTrainer",headingTag:"h2"}}),Ea=new f({props:{name:"class trl.SFTTrainer",anchor:"trl.SFTTrainer",parameters:[{name:"model",val:": Union = None"},{name:"args",val:": Optional = None"},{name:"data_collator",val:": Optional = None"},{name:"train_dataset",val:": Optional = None"},{name:"eval_dataset",val:": Union = None"},{name:"tokenizer",val:": Optional = None"},{name:"model_init",val:": Optional = None"},{name:"compute_metrics",val:": Optional = None"},{name:"callbacks",val:": Optional = None"},{name:"optimizers",val:": Tuple = (None, None)"},{name:"preprocess_logits_for_metrics",val:": Optional = None"},{name:"peft_config",val:": Optional = None"},{name:"dataset_text_field",val:": Optional = None"},{name:"packing",val:": Optional = False"},{name:"formatting_func",val:": Optional = None"},{name:"max_seq_length",val:": Optional = None"},{name:"infinite",val:": Optional = None"},{name:"num_of_sequences",val:": Optional = 1024"},{name:"chars_per_token",val:": Optional = 3.6"},{name:"dataset_num_proc",val:": Optional = None"},{name:"dataset_batch_size",val:": int = 1000"},{name:"neftune_noise_alpha",val:": Optional = None"},{name:"model_init_kwargs",val:": Optional = None"},{name:"dataset_kwargs",val:": Optional = None"},{name:"eval_packing",val:": Optional = None"}],parametersDescription:[{anchor:"trl.SFTTrainer.model",description:`<strong>model</strong> (Union[<code>transformers.PreTrainedModel</code>, <code>nn.Module</code>, <code>str</code>]) &#x2014;
The model to train, can be a <code>PreTrainedModel</code>, a <code>torch.nn.Module</code> or a string with the model name to
load from cache or download. The model can be also converted to a <code>PeftModel</code> if a <code>PeftConfig</code> object is
passed to the <code>peft_config</code> argument.`,name:"model"},{anchor:"trl.SFTTrainer.args",description:`<strong>args</strong> (Optional<a href="https://huggingface.co/docs/transformers/main/en/main_classes/trainer#transformers.TrainingArguments" rel="nofollow">transformers.TrainingArguments</a>) &#x2014;
The arguments to tweak for training. Please refer to the official documentation of <code>transformers.TrainingArguments</code>
for more information.`,name:"args"},{anchor:"trl.SFTTrainer.data_collator",description:`<strong>data_collator</strong> (Optional<code>transformers.DataCollator</code>) &#x2014;
The data collator to use for training.`,name:"data_collator"},{anchor:"trl.SFTTrainer.train_dataset",description:`<strong>train_dataset</strong> (Optional<a href="https://huggingface.co/docs/datasets/main/en/package_reference/main_classes#datasets.Dataset" rel="nofollow">datasets.Dataset</a>) &#x2014;
The dataset to use for training. We recommend users to use <code>trl.trainer.ConstantLengthDataset</code> to create their dataset.`,name:"train_dataset"},{anchor:"trl.SFTTrainer.eval_dataset",description:`<strong>eval_dataset</strong> (Optional[Union[<code>datasets.Dataset</code>, Dict[<code>str</code>, <code>datasets.Dataset</code>]]]) &#x2014;
The dataset to use for evaluation. We recommend users to use <code>trl.trainer.ConstantLengthDataset</code> to create their dataset.`,name:"eval_dataset"},{anchor:"trl.SFTTrainer.tokenizer",description:`<strong>tokenizer</strong> (Optional<a href="https://huggingface.co/docs/transformers/main/en/main_classes/tokenizer#transformers.PreTrainedTokenizer" rel="nofollow">transformers.PreTrainedTokenizer</a>) &#x2014;
The tokenizer to use for training. If not specified, the tokenizer associated to the model will be used.`,name:"tokenizer"},{anchor:"trl.SFTTrainer.model_init",description:`<strong>model_init</strong> (<code>Callable[[], transformers.PreTrainedModel]</code>) &#x2014;
The model initializer to use for training. If None is specified, the default model initializer will be used.`,name:"model_init"},{anchor:"trl.SFTTrainer.compute_metrics",description:`<strong>compute_metrics</strong> (<code>Callable[[transformers.EvalPrediction], Dict]</code>, <em>optional</em> defaults to None) &#x2014;
The function used to compute metrics during evaluation. It should return a dictionary mapping metric names to metric values.
If not specified, only the loss will be computed during evaluation.`,name:"compute_metrics"},{anchor:"trl.SFTTrainer.callbacks",description:`<strong>callbacks</strong> (<code>List[transformers.TrainerCallback]</code>) &#x2014;
The callbacks to use for training.`,name:"callbacks"},{anchor:"trl.SFTTrainer.optimizers",description:`<strong>optimizers</strong> (<code>Tuple[torch.optim.Optimizer, torch.optim.lr_scheduler.LambdaLR]</code>) &#x2014;
The optimizer and scheduler to use for training.`,name:"optimizers"},{anchor:"trl.SFTTrainer.preprocess_logits_for_metrics",description:`<strong>preprocess_logits_for_metrics</strong> (<code>Callable[[torch.Tensor, torch.Tensor], torch.Tensor]</code>) &#x2014;
The function to use to preprocess the logits before computing the metrics.`,name:"preprocess_logits_for_metrics"},{anchor:"trl.SFTTrainer.peft_config",description:`<strong>peft_config</strong> (<code>Optional[PeftConfig]</code>) &#x2014;
The PeftConfig object to use to initialize the PeftModel.`,name:"peft_config"},{anchor:"trl.SFTTrainer.formatting_func",description:`<strong>formatting_func</strong> (<code>Optional[Callable]</code>) &#x2014;
The formatting function to be used for creating the <code>ConstantLengthDataset</code>.`,name:"formatting_func"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/sft_trainer.py#L58"}}),Ra=new D({props:{title:"set_seed",local:"trl.set_seed",headingTag:"h2"}}),Ua=new f({props:{name:"trl.set_seed",anchor:"trl.set_seed",parameters:[{name:"seed",val:": int"}],parametersDescription:[{anchor:"trl.set_seed.seed",description:"<strong>seed</strong> (<code>int</code>) &#x2014; The seed to set.",name:"seed"}],source:"https://github.com/huggingface/trl/blob/main/trl/core.py#L245"}}),Ha=new qm({props:{source:"https://github.com/huggingface/trl/blob/main/docs/source/trainer.mdx"}}),{c(){ee=o("meta"),tr=a(),Yo=o("p"),ar=a(),s(et.$$.fragment),nr=a(),tt=o("p"),tt.innerHTML=Md,or=a(),s(at.$$.fragment),rr=a(),E=o("div"),s(nt.$$.fragment),Il=a(),Va=o("p"),Va.innerHTML=qd,Ml=a(),Aa=o("p"),Aa.innerHTML=Ed,lr=a(),s(ot.$$.fragment),ir=a(),x=o("div"),s(rt.$$.fragment),ql=a(),Ka=o("p"),Ka.textContent=Rd,El=a(),re=o("div"),s(lt.$$.fragment),Rl=a(),ja=o("p"),ja.innerHTML=Ud,Ul=a(),A=o("div"),s(it.$$.fragment),Hl=a(),Sa=o("p"),Sa.textContent=Hd,Vl=a(),Wa=o("p"),Wa.textContent=Vd,Al=a(),le=o("div"),s(st.$$.fragment),Kl=a(),Ga=o("p"),Ga.textContent=Ad,jl=a(),ie=o("div"),s(dt.$$.fragment),Sl=a(),Ba=o("p"),Ba.textContent=Kd,Wl=a(),K=o("div"),s(ct.$$.fragment),Gl=a(),Za=o("p"),Za.innerHTML=jd,Bl=a(),Ja=o("p"),Ja.textContent=Sd,Zl=a(),se=o("div"),s(mt.$$.fragment),Jl=a(),Qa=o("p"),Qa.textContent=Wd,Ql=a(),de=o("div"),s(pt.$$.fragment),Xl=a(),Xa=o("p"),Xa.textContent=Gd,Yl=a(),ce=o("div"),s(gt.$$.fragment),ei=a(),Ya=o("p"),Ya.textContent=Bd,ti=a(),me=o("div"),s(_t.$$.fragment),ai=a(),en=o("p"),en.innerHTML=Zd,ni=a(),L=o("div"),s(ht.$$.fragment),oi=a(),tn=o("p"),tn.textContent=Jd,ri=a(),an=o("p"),an.textContent=Qd,li=a(),nn=o("p"),nn.textContent=Xd,sr=a(),s(ut.$$.fragment),dr=a(),te=o("div"),s(ft.$$.fragment),ii=a(),on=o("p"),on.textContent=Yd,cr=a(),s(vt.$$.fragment),mr=a(),N=o("div"),s(bt.$$.fragment),si=a(),rn=o("p"),rn.innerHTML=ec,di=a(),pe=o("div"),s(Tt.$$.fragment),ci=a(),ln=o("p"),ln.textContent=tc,mi=a(),ge=o("div"),s(Ot.$$.fragment),pi=a(),sn=o("p"),sn.textContent=ac,gi=a(),z=o("div"),s(xt.$$.fragment),_i=a(),dn=o("p"),dn.textContent=nc,hi=a(),cn=o("p"),cn.textContent=oc,ui=a(),mn=o("ul"),mn.innerHTML=rc,fi=a(),_e=o("div"),s($t.$$.fragment),vi=a(),pn=o("p"),pn.textContent=lc,pr=a(),s(Pt.$$.fragment),gr=a(),b=o("div"),s(wt.$$.fragment),bi=a(),gn=o("p"),gn.textContent=ic,Ti=a(),he=o("div"),s(yt.$$.fragment),Oi=a(),_n=o("p"),_n.innerHTML=sc,xi=a(),ue=o("div"),s(Ct.$$.fragment),$i=a(),hn=o("p"),hn.textContent=dc,Pi=a(),j=o("div"),s(kt.$$.fragment),wi=a(),un=o("p"),un.textContent=cc,yi=a(),fn=o("p"),fn.textContent=mc,Ci=a(),fe=o("div"),s(Nt.$$.fragment),ki=a(),vn=o("p"),vn.textContent=pc,Ni=a(),ve=o("div"),s(Dt.$$.fragment),Di=a(),bn=o("p"),bn.textContent=gc,Fi=a(),S=o("div"),s(Ft.$$.fragment),Li=a(),Tn=o("p"),Tn.innerHTML=_c,zi=a(),On=o("p"),On.textContent=hc,Ii=a(),be=o("div"),s(Lt.$$.fragment),Mi=a(),xn=o("p"),xn.textContent=uc,qi=a(),Te=o("div"),s(zt.$$.fragment),Ei=a(),$n=o("p"),$n.textContent=fc,Ri=a(),Oe=o("div"),s(It.$$.fragment),Ui=a(),Pn=o("p"),Pn.textContent=vc,Hi=a(),W=o("div"),s(Mt.$$.fragment),Vi=a(),wn=o("p"),wn.innerHTML=bc,Ai=a(),yn=o("p"),yn.innerHTML=Tc,Ki=a(),G=o("div"),s(qt.$$.fragment),ji=a(),Cn=o("p"),Cn.innerHTML=Oc,Si=a(),kn=o("p"),kn.innerHTML=xc,Wi=a(),xe=o("div"),s(Et.$$.fragment),Gi=a(),Nn=o("p"),Nn.innerHTML=$c,Bi=a(),$e=o("div"),s(Rt.$$.fragment),Zi=a(),Dn=o("p"),Dn.textContent=Pc,Ji=a(),I=o("div"),s(Ut.$$.fragment),Qi=a(),Fn=o("p"),Fn.textContent=wc,Xi=a(),Ln=o("p"),Ln.textContent=yc,Yi=a(),zn=o("p"),zn.textContent=Cc,_r=a(),s(Ht.$$.fragment),hr=a(),R=o("div"),s(Vt.$$.fragment),es=a(),In=o("p"),In.textContent=kc,ts=a(),Pe=o("div"),s(At.$$.fragment),as=a(),Mn=o("p"),Mn.textContent=Nc,ur=a(),s(Kt.$$.fragment),fr=a(),U=o("div"),s(jt.$$.fragment),ns=a(),qn=o("p"),qn.innerHTML=Dc,os=a(),En=o("p"),En.innerHTML=Fc,vr=a(),s(St.$$.fragment),br=a(),$=o("div"),s(Wt.$$.fragment),rs=a(),Rn=o("p"),Rn.textContent=Lc,ls=a(),we=o("div"),s(Gt.$$.fragment),is=a(),Un=o("p"),Un.textContent=zc,ss=a(),B=o("div"),s(Bt.$$.fragment),ds=a(),Hn=o("p"),Hn.innerHTML=Ic,cs=a(),Vn=o("p"),Vn.textContent=Mc,ms=a(),ye=o("div"),s(Zt.$$.fragment),ps=a(),An=o("p"),An.textContent=qc,gs=a(),Ce=o("div"),s(Jt.$$.fragment),_s=a(),Kn=o("p"),Kn.textContent=Ec,hs=a(),ke=o("div"),s(Qt.$$.fragment),us=a(),jn=o("p"),jn.textContent=Rc,fs=a(),Z=o("div"),s(Xt.$$.fragment),vs=a(),Sn=o("p"),Sn.innerHTML=Uc,bs=a(),Wn=o("p"),Wn.innerHTML=Hc,Ts=a(),J=o("div"),s(Yt.$$.fragment),Os=a(),Gn=o("p"),Gn.innerHTML=Vc,xs=a(),Bn=o("p"),Bn.innerHTML=Ac,$s=a(),Ne=o("div"),s(ea.$$.fragment),Ps=a(),Zn=o("p"),Zn.textContent=Kc,ws=a(),De=o("div"),s(ta.$$.fragment),ys=a(),Jn=o("p"),Jn.innerHTML=jc,Cs=a(),Fe=o("div"),s(aa.$$.fragment),ks=a(),Qn=o("p"),Qn.textContent=Sc,Tr=a(),s(na.$$.fragment),Or=a(),H=o("div"),s(oa.$$.fragment),Ns=a(),Xn=o("p"),Xn.innerHTML=Wc,Ds=a(),Yn=o("p"),Yn.innerHTML=Gc,xr=a(),s(ra.$$.fragment),$r=a(),P=o("div"),s(la.$$.fragment),Fs=a(),eo=o("p"),eo.textContent=Bc,Ls=a(),Le=o("div"),s(ia.$$.fragment),zs=a(),to=o("p"),to.innerHTML=Zc,Is=a(),Q=o("div"),s(sa.$$.fragment),Ms=a(),ao=o("p"),ao.textContent=Jc,qs=a(),no=o("p"),no.textContent=Qc,Es=a(),ze=o("div"),s(da.$$.fragment),Rs=a(),oo=o("p"),oo.textContent=Xc,Us=a(),X=o("div"),s(ca.$$.fragment),Hs=a(),ro=o("p"),ro.innerHTML=Yc,Vs=a(),lo=o("p"),lo.textContent=em,As=a(),Ie=o("div"),s(ma.$$.fragment),Ks=a(),io=o("p"),io.textContent=tm,js=a(),Me=o("div"),s(pa.$$.fragment),Ss=a(),so=o("p"),so.textContent=am,Ws=a(),qe=o("div"),s(ga.$$.fragment),Gs=a(),co=o("p"),co.textContent=nm,Bs=a(),Ee=o("div"),s(_a.$$.fragment),Zs=a(),mo=o("p"),mo.innerHTML=om,Js=a(),Re=o("div"),s(ha.$$.fragment),Qs=a(),po=o("p"),po.textContent=rm,Xs=a(),M=o("div"),s(ua.$$.fragment),Ys=a(),go=o("p"),go.textContent=lm,ed=a(),_o=o("p"),_o.textContent=im,td=a(),ho=o("p"),ho.textContent=sm,Pr=a(),s(fa.$$.fragment),wr=a(),ae=o("div"),s(va.$$.fragment),ad=a(),uo=o("p"),uo.textContent=dm,yr=a(),s(ba.$$.fragment),Cr=a(),O=o("div"),s(Ta.$$.fragment),nd=a(),fo=o("p"),fo.innerHTML=cm,od=a(),Ue=o("div"),s(Oa.$$.fragment),rd=a(),vo=o("p"),vo.textContent=mm,ld=a(),He=o("div"),s(xa.$$.fragment),id=a(),bo=o("p"),bo.textContent=pm,sd=a(),Ve=o("div"),s($a.$$.fragment),dd=a(),To=o("p"),To.textContent=gm,cd=a(),Ae=o("div"),s(Pa.$$.fragment),md=a(),Oo=o("p"),Oo.textContent=_m,pd=a(),Ke=o("div"),s(wa.$$.fragment),gd=a(),xo=o("p"),xo.innerHTML=hm,_d=a(),je=o("div"),s(ya.$$.fragment),hd=a(),$o=o("p"),$o.textContent=um,ud=a(),Se=o("div"),s(Ca.$$.fragment),fd=a(),Po=o("p"),Po.textContent=fm,vd=a(),We=o("div"),s(ka.$$.fragment),bd=a(),wo=o("p"),wo.textContent=vm,Td=a(),Ge=o("div"),s(Na.$$.fragment),Od=a(),yo=o("p"),yo.textContent=bm,xd=a(),Be=o("div"),s(Da.$$.fragment),$d=a(),Co=o("p"),Co.textContent=Tm,Pd=a(),Ze=o("div"),s(Fa.$$.fragment),wd=a(),ko=o("p"),ko.textContent=Om,kr=a(),s(La.$$.fragment),Nr=a(),V=o("div"),s(za.$$.fragment),yd=a(),No=o("p"),No.innerHTML=xm,Cd=a(),Do=o("p"),Do.innerHTML=$m,Dr=a(),s(Ia.$$.fragment),Fr=a(),F=o("div"),s(Ma.$$.fragment),kd=a(),Fo=o("p"),Fo.innerHTML=Pm,Nd=a(),Lo=o("p"),Lo.innerHTML=wm,Dd=a(),zo=o("ul"),zo.innerHTML=ym,Fd=a(),Io=o("p"),Io.innerHTML=Cm,Lr=a(),s(qa.$$.fragment),zr=a(),ne=o("div"),s(Ea.$$.fragment),Ld=a(),Mo=o("p"),Mo.innerHTML=km,Ir=a(),s(Ra.$$.fragment),Mr=a(),oe=o("div"),s(Ua.$$.fragment),zd=a(),qo=o("p"),qo.innerHTML=Nm,qr=a(),s(Ha.$$.fragment),Er=a(),er=o("p"),this.h()},l(e){const u=Mm("svelte-u9bgzb",document.head);ee=r(u,"META",{name:!0,content:!0}),u.forEach(l),tr=n(e),Yo=r(e,"P",{}),_(Yo).forEach(l),ar=n(e),d(et.$$.fragment,e),nr=n(e),tt=r(e,"P",{"data-svelte-h":!0}),i(tt)!=="svelte-dxrcnp"&&(tt.innerHTML=Md),or=n(e),d(at.$$.fragment,e),rr=n(e),E=r(e,"DIV",{class:!0});var Eo=_(E);d(nt.$$.fragment,Eo),Il=n(Eo),Va=r(Eo,"P",{"data-svelte-h":!0}),i(Va)!=="svelte-1w6qkim"&&(Va.innerHTML=qd),Ml=n(Eo),Aa=r(Eo,"P",{"data-svelte-h":!0}),i(Aa)!=="svelte-1xl7jqc"&&(Aa.innerHTML=Ed),Eo.forEach(l),lr=n(e),d(ot.$$.fragment,e),ir=n(e),x=r(e,"DIV",{class:!0});var y=_(x);d(rt.$$.fragment,y),ql=n(y),Ka=r(y,"P",{"data-svelte-h":!0}),i(Ka)!=="svelte-1qqtmoh"&&(Ka.textContent=Rd),El=n(y),re=r(y,"DIV",{class:!0});var Ur=_(re);d(lt.$$.fragment,Ur),Rl=n(Ur),ja=r(Ur,"P",{"data-svelte-h":!0}),i(ja)!=="svelte-mcz8nm"&&(ja.innerHTML=Ud),Ur.forEach(l),Ul=n(y),A=r(y,"DIV",{class:!0});var Ro=_(A);d(it.$$.fragment,Ro),Hl=n(Ro),Sa=r(Ro,"P",{"data-svelte-h":!0}),i(Sa)!=="svelte-16i1nac"&&(Sa.textContent=Hd),Vl=n(Ro),Wa=r(Ro,"P",{"data-svelte-h":!0}),i(Wa)!=="svelte-tgti68"&&(Wa.textContent=Vd),Ro.forEach(l),Al=n(y),le=r(y,"DIV",{class:!0});var Hr=_(le);d(st.$$.fragment,Hr),Kl=n(Hr),Ga=r(Hr,"P",{"data-svelte-h":!0}),i(Ga)!=="svelte-1cvsgkk"&&(Ga.textContent=Ad),Hr.forEach(l),jl=n(y),ie=r(y,"DIV",{class:!0});var Vr=_(ie);d(dt.$$.fragment,Vr),Sl=n(Vr),Ba=r(Vr,"P",{"data-svelte-h":!0}),i(Ba)!=="svelte-1l2rxe2"&&(Ba.textContent=Kd),Vr.forEach(l),Wl=n(y),K=r(y,"DIV",{class:!0});var Uo=_(K);d(ct.$$.fragment,Uo),Gl=n(Uo),Za=r(Uo,"P",{"data-svelte-h":!0}),i(Za)!=="svelte-8qlty5"&&(Za.innerHTML=jd),Bl=n(Uo),Ja=r(Uo,"P",{"data-svelte-h":!0}),i(Ja)!=="svelte-1tyo99t"&&(Ja.textContent=Sd),Uo.forEach(l),Zl=n(y),se=r(y,"DIV",{class:!0});var Ar=_(se);d(mt.$$.fragment,Ar),Jl=n(Ar),Qa=r(Ar,"P",{"data-svelte-h":!0}),i(Qa)!=="svelte-4nmimv"&&(Qa.textContent=Wd),Ar.forEach(l),Ql=n(y),de=r(y,"DIV",{class:!0});var Kr=_(de);d(pt.$$.fragment,Kr),Xl=n(Kr),Xa=r(Kr,"P",{"data-svelte-h":!0}),i(Xa)!=="svelte-4kzfyw"&&(Xa.textContent=Gd),Kr.forEach(l),Yl=n(y),ce=r(y,"DIV",{class:!0});var jr=_(ce);d(gt.$$.fragment,jr),ei=n(jr),Ya=r(jr,"P",{"data-svelte-h":!0}),i(Ya)!=="svelte-18uwvbi"&&(Ya.textContent=Bd),jr.forEach(l),ti=n(y),me=r(y,"DIV",{class:!0});var Sr=_(me);d(_t.$$.fragment,Sr),ai=n(Sr),en=r(Sr,"P",{"data-svelte-h":!0}),i(en)!=="svelte-nqksfz"&&(en.innerHTML=Zd),Sr.forEach(l),ni=n(y),L=r(y,"DIV",{class:!0});var Je=_(L);d(ht.$$.fragment,Je),oi=n(Je),tn=r(Je,"P",{"data-svelte-h":!0}),i(tn)!=="svelte-1a53vwp"&&(tn.textContent=Jd),ri=n(Je),an=r(Je,"P",{"data-svelte-h":!0}),i(an)!=="svelte-1mn1gnw"&&(an.textContent=Qd),li=n(Je),nn=r(Je,"P",{"data-svelte-h":!0}),i(nn)!=="svelte-1xvpyih"&&(nn.textContent=Xd),Je.forEach(l),y.forEach(l),sr=n(e),d(ut.$$.fragment,e),dr=n(e),te=r(e,"DIV",{class:!0});var Wr=_(te);d(ft.$$.fragment,Wr),ii=n(Wr),on=r(Wr,"P",{"data-svelte-h":!0}),i(on)!=="svelte-2zpx1f"&&(on.textContent=Yd),Wr.forEach(l),cr=n(e),d(vt.$$.fragment,e),mr=n(e),N=r(e,"DIV",{class:!0});var q=_(N);d(bt.$$.fragment,q),si=n(q),rn=r(q,"P",{"data-svelte-h":!0}),i(rn)!=="svelte-8q861t"&&(rn.innerHTML=ec),di=n(q),pe=r(q,"DIV",{class:!0});var Gr=_(pe);d(Tt.$$.fragment,Gr),ci=n(Gr),ln=r(Gr,"P",{"data-svelte-h":!0}),i(ln)!=="svelte-1ag17u3"&&(ln.textContent=tc),Gr.forEach(l),mi=n(q),ge=r(q,"DIV",{class:!0});var Br=_(ge);d(Ot.$$.fragment,Br),pi=n(Br),sn=r(Br,"P",{"data-svelte-h":!0}),i(sn)!=="svelte-3jfrz9"&&(sn.textContent=ac),Br.forEach(l),gi=n(q),z=r(q,"DIV",{class:!0});var Qe=_(z);d(xt.$$.fragment,Qe),_i=n(Qe),dn=r(Qe,"P",{"data-svelte-h":!0}),i(dn)!=="svelte-r6y15n"&&(dn.textContent=nc),hi=n(Qe),cn=r(Qe,"P",{"data-svelte-h":!0}),i(cn)!=="svelte-imqqfp"&&(cn.textContent=oc),ui=n(Qe),mn=r(Qe,"UL",{"data-svelte-h":!0}),i(mn)!=="svelte-105j238"&&(mn.innerHTML=rc),Qe.forEach(l),fi=n(q),_e=r(q,"DIV",{class:!0});var Zr=_(_e);d($t.$$.fragment,Zr),vi=n(Zr),pn=r(Zr,"P",{"data-svelte-h":!0}),i(pn)!=="svelte-1an944l"&&(pn.textContent=lc),Zr.forEach(l),q.forEach(l),pr=n(e),d(Pt.$$.fragment,e),gr=n(e),b=r(e,"DIV",{class:!0});var T=_(b);d(wt.$$.fragment,T),bi=n(T),gn=r(T,"P",{"data-svelte-h":!0}),i(gn)!=="svelte-n6cc8y"&&(gn.textContent=ic),Ti=n(T),he=r(T,"DIV",{class:!0});var Jr=_(he);d(yt.$$.fragment,Jr),Oi=n(Jr),_n=r(Jr,"P",{"data-svelte-h":!0}),i(_n)!=="svelte-mcz8nm"&&(_n.innerHTML=sc),Jr.forEach(l),xi=n(T),ue=r(T,"DIV",{class:!0});var Qr=_(ue);d(Ct.$$.fragment,Qr),$i=n(Qr),hn=r(Qr,"P",{"data-svelte-h":!0}),i(hn)!=="svelte-10t1062"&&(hn.textContent=dc),Qr.forEach(l),Pi=n(T),j=r(T,"DIV",{class:!0});var Ho=_(j);d(kt.$$.fragment,Ho),wi=n(Ho),un=r(Ho,"P",{"data-svelte-h":!0}),i(un)!=="svelte-16i1nac"&&(un.textContent=cc),yi=n(Ho),fn=r(Ho,"P",{"data-svelte-h":!0}),i(fn)!=="svelte-tgti68"&&(fn.textContent=mc),Ho.forEach(l),Ci=n(T),fe=r(T,"DIV",{class:!0});var Xr=_(fe);d(Nt.$$.fragment,Xr),ki=n(Xr),vn=r(Xr,"P",{"data-svelte-h":!0}),i(vn)!=="svelte-1cvsgkk"&&(vn.textContent=pc),Xr.forEach(l),Ni=n(T),ve=r(T,"DIV",{class:!0});var Yr=_(ve);d(Dt.$$.fragment,Yr),Di=n(Yr),bn=r(Yr,"P",{"data-svelte-h":!0}),i(bn)!=="svelte-ymgxq7"&&(bn.textContent=gc),Yr.forEach(l),Fi=n(T),S=r(T,"DIV",{class:!0});var Vo=_(S);d(Ft.$$.fragment,Vo),Li=n(Vo),Tn=r(Vo,"P",{"data-svelte-h":!0}),i(Tn)!=="svelte-8qlty5"&&(Tn.innerHTML=_c),zi=n(Vo),On=r(Vo,"P",{"data-svelte-h":!0}),i(On)!=="svelte-1tyo99t"&&(On.textContent=hc),Vo.forEach(l),Ii=n(T),be=r(T,"DIV",{class:!0});var el=_(be);d(Lt.$$.fragment,el),Mi=n(el),xn=r(el,"P",{"data-svelte-h":!0}),i(xn)!=="svelte-4nmimv"&&(xn.textContent=uc),el.forEach(l),qi=n(T),Te=r(T,"DIV",{class:!0});var tl=_(Te);d(zt.$$.fragment,tl),Ei=n(tl),$n=r(tl,"P",{"data-svelte-h":!0}),i($n)!=="svelte-11q8u7l"&&($n.textContent=fc),tl.forEach(l),Ri=n(T),Oe=r(T,"DIV",{class:!0});var al=_(Oe);d(It.$$.fragment,al),Ui=n(al),Pn=r(al,"P",{"data-svelte-h":!0}),i(Pn)!=="svelte-18uwvbi"&&(Pn.textContent=vc),al.forEach(l),Hi=n(T),W=r(T,"DIV",{class:!0});var Ao=_(W);d(Mt.$$.fragment,Ao),Vi=n(Ao),wn=r(Ao,"P",{"data-svelte-h":!0}),i(wn)!=="svelte-xesobz"&&(wn.innerHTML=bc),Ai=n(Ao),yn=r(Ao,"P",{"data-svelte-h":!0}),i(yn)!=="svelte-qg43tm"&&(yn.innerHTML=Tc),Ao.forEach(l),Ki=n(T),G=r(T,"DIV",{class:!0});var Ko=_(G);d(qt.$$.fragment,Ko),ji=n(Ko),Cn=r(Ko,"P",{"data-svelte-h":!0}),i(Cn)!=="svelte-dkae9b"&&(Cn.innerHTML=Oc),Si=n(Ko),kn=r(Ko,"P",{"data-svelte-h":!0}),i(kn)!=="svelte-hmd5cw"&&(kn.innerHTML=xc),Ko.forEach(l),Wi=n(T),xe=r(T,"DIV",{class:!0});var nl=_(xe);d(Et.$$.fragment,nl),Gi=n(nl),Nn=r(nl,"P",{"data-svelte-h":!0}),i(Nn)!=="svelte-nqksfz"&&(Nn.innerHTML=$c),nl.forEach(l),Bi=n(T),$e=r(T,"DIV",{class:!0});var ol=_($e);d(Rt.$$.fragment,ol),Zi=n(ol),Dn=r(ol,"P",{"data-svelte-h":!0}),i(Dn)!=="svelte-17kjsy4"&&(Dn.textContent=Pc),ol.forEach(l),Ji=n(T),I=r(T,"DIV",{class:!0});var Xe=_(I);d(Ut.$$.fragment,Xe),Qi=n(Xe),Fn=r(Xe,"P",{"data-svelte-h":!0}),i(Fn)!=="svelte-1861yti"&&(Fn.textContent=wc),Xi=n(Xe),Ln=r(Xe,"P",{"data-svelte-h":!0}),i(Ln)!=="svelte-1mn1gnw"&&(Ln.textContent=yc),Yi=n(Xe),zn=r(Xe,"P",{"data-svelte-h":!0}),i(zn)!=="svelte-1xvpyih"&&(zn.textContent=Cc),Xe.forEach(l),T.forEach(l),_r=n(e),d(Ht.$$.fragment,e),hr=n(e),R=r(e,"DIV",{class:!0});var jo=_(R);d(Vt.$$.fragment,jo),es=n(jo),In=r(jo,"P",{"data-svelte-h":!0}),i(In)!=="svelte-xqyw6w"&&(In.textContent=kc),ts=n(jo),Pe=r(jo,"DIV",{class:!0});var rl=_(Pe);d(At.$$.fragment,rl),as=n(rl),Mn=r(rl,"P",{"data-svelte-h":!0}),i(Mn)!=="svelte-v7dhdf"&&(Mn.textContent=Nc),rl.forEach(l),jo.forEach(l),ur=n(e),d(Kt.$$.fragment,e),fr=n(e),U=r(e,"DIV",{class:!0});var So=_(U);d(jt.$$.fragment,So),ns=n(So),qn=r(So,"P",{"data-svelte-h":!0}),i(qn)!=="svelte-1anbnaa"&&(qn.innerHTML=Dc),os=n(So),En=r(So,"P",{"data-svelte-h":!0}),i(En)!=="svelte-1xl7jqc"&&(En.innerHTML=Fc),So.forEach(l),vr=n(e),d(St.$$.fragment,e),br=n(e),$=r(e,"DIV",{class:!0});var C=_($);d(Wt.$$.fragment,C),rs=n(C),Rn=r(C,"P",{"data-svelte-h":!0}),i(Rn)!=="svelte-hyhzxp"&&(Rn.textContent=Lc),ls=n(C),we=r(C,"DIV",{class:!0});var ll=_(we);d(Gt.$$.fragment,ll),is=n(ll),Un=r(ll,"P",{"data-svelte-h":!0}),i(Un)!=="svelte-pt6g01"&&(Un.textContent=zc),ll.forEach(l),ss=n(C),B=r(C,"DIV",{class:!0});var Wo=_(B);d(Bt.$$.fragment,Wo),ds=n(Wo),Hn=r(Wo,"P",{"data-svelte-h":!0}),i(Hn)!=="svelte-8qlty5"&&(Hn.innerHTML=Ic),cs=n(Wo),Vn=r(Wo,"P",{"data-svelte-h":!0}),i(Vn)!=="svelte-1tyo99t"&&(Vn.textContent=Mc),Wo.forEach(l),ms=n(C),ye=r(C,"DIV",{class:!0});var il=_(ye);d(Zt.$$.fragment,il),ps=n(il),An=r(il,"P",{"data-svelte-h":!0}),i(An)!=="svelte-4nmimv"&&(An.textContent=qc),il.forEach(l),gs=n(C),Ce=r(C,"DIV",{class:!0});var sl=_(Ce);d(Jt.$$.fragment,sl),_s=n(sl),Kn=r(sl,"P",{"data-svelte-h":!0}),i(Kn)!=="svelte-db7iek"&&(Kn.textContent=Ec),sl.forEach(l),hs=n(C),ke=r(C,"DIV",{class:!0});var dl=_(ke);d(Qt.$$.fragment,dl),us=n(dl),jn=r(dl,"P",{"data-svelte-h":!0}),i(jn)!=="svelte-18uwvbi"&&(jn.textContent=Rc),dl.forEach(l),fs=n(C),Z=r(C,"DIV",{class:!0});var Go=_(Z);d(Xt.$$.fragment,Go),vs=n(Go),Sn=r(Go,"P",{"data-svelte-h":!0}),i(Sn)!=="svelte-xesobz"&&(Sn.innerHTML=Uc),bs=n(Go),Wn=r(Go,"P",{"data-svelte-h":!0}),i(Wn)!=="svelte-qg43tm"&&(Wn.innerHTML=Hc),Go.forEach(l),Ts=n(C),J=r(C,"DIV",{class:!0});var Bo=_(J);d(Yt.$$.fragment,Bo),Os=n(Bo),Gn=r(Bo,"P",{"data-svelte-h":!0}),i(Gn)!=="svelte-dkae9b"&&(Gn.innerHTML=Vc),xs=n(Bo),Bn=r(Bo,"P",{"data-svelte-h":!0}),i(Bn)!=="svelte-hmd5cw"&&(Bn.innerHTML=Ac),Bo.forEach(l),$s=n(C),Ne=r(C,"DIV",{class:!0});var cl=_(Ne);d(ea.$$.fragment,cl),Ps=n(cl),Zn=r(cl,"P",{"data-svelte-h":!0}),i(Zn)!=="svelte-svckwe"&&(Zn.textContent=Kc),cl.forEach(l),ws=n(C),De=r(C,"DIV",{class:!0});var ml=_(De);d(ta.$$.fragment,ml),ys=n(ml),Jn=r(ml,"P",{"data-svelte-h":!0}),i(Jn)!=="svelte-nqksfz"&&(Jn.innerHTML=jc),ml.forEach(l),Cs=n(C),Fe=r(C,"DIV",{class:!0});var pl=_(Fe);d(aa.$$.fragment,pl),ks=n(pl),Qn=r(pl,"P",{"data-svelte-h":!0}),i(Qn)!=="svelte-17kjsy4"&&(Qn.textContent=Sc),pl.forEach(l),C.forEach(l),Tr=n(e),d(na.$$.fragment,e),Or=n(e),H=r(e,"DIV",{class:!0});var Zo=_(H);d(oa.$$.fragment,Zo),Ns=n(Zo),Xn=r(Zo,"P",{"data-svelte-h":!0}),i(Xn)!=="svelte-t2n6nv"&&(Xn.innerHTML=Wc),Ds=n(Zo),Yn=r(Zo,"P",{"data-svelte-h":!0}),i(Yn)!=="svelte-1xl7jqc"&&(Yn.innerHTML=Gc),Zo.forEach(l),xr=n(e),d(ra.$$.fragment,e),$r=n(e),P=r(e,"DIV",{class:!0});var k=_(P);d(la.$$.fragment,k),Fs=n(k),eo=r(k,"P",{"data-svelte-h":!0}),i(eo)!=="svelte-1ggwo37"&&(eo.textContent=Bc),Ls=n(k),Le=r(k,"DIV",{class:!0});var gl=_(Le);d(ia.$$.fragment,gl),zs=n(gl),to=r(gl,"P",{"data-svelte-h":!0}),i(to)!=="svelte-mcz8nm"&&(to.innerHTML=Zc),gl.forEach(l),Is=n(k),Q=r(k,"DIV",{class:!0});var Jo=_(Q);d(sa.$$.fragment,Jo),Ms=n(Jo),ao=r(Jo,"P",{"data-svelte-h":!0}),i(ao)!=="svelte-16i1nac"&&(ao.textContent=Jc),qs=n(Jo),no=r(Jo,"P",{"data-svelte-h":!0}),i(no)!=="svelte-tgti68"&&(no.textContent=Qc),Jo.forEach(l),Es=n(k),ze=r(k,"DIV",{class:!0});var _l=_(ze);d(da.$$.fragment,_l),Rs=n(_l),oo=r(_l,"P",{"data-svelte-h":!0}),i(oo)!=="svelte-1cvsgkk"&&(oo.textContent=Xc),_l.forEach(l),Us=n(k),X=r(k,"DIV",{class:!0});var Qo=_(X);d(ca.$$.fragment,Qo),Hs=n(Qo),ro=r(Qo,"P",{"data-svelte-h":!0}),i(ro)!=="svelte-8qlty5"&&(ro.innerHTML=Yc),Vs=n(Qo),lo=r(Qo,"P",{"data-svelte-h":!0}),i(lo)!=="svelte-1tyo99t"&&(lo.textContent=em),Qo.forEach(l),As=n(k),Ie=r(k,"DIV",{class:!0});var hl=_(Ie);d(ma.$$.fragment,hl),Ks=n(hl),io=r(hl,"P",{"data-svelte-h":!0}),i(io)!=="svelte-4nmimv"&&(io.textContent=tm),hl.forEach(l),js=n(k),Me=r(k,"DIV",{class:!0});var ul=_(Me);d(pa.$$.fragment,ul),Ss=n(ul),so=r(ul,"P",{"data-svelte-h":!0}),i(so)!=="svelte-ndgk7s"&&(so.textContent=am),ul.forEach(l),Ws=n(k),qe=r(k,"DIV",{class:!0});var fl=_(qe);d(ga.$$.fragment,fl),Gs=n(fl),co=r(fl,"P",{"data-svelte-h":!0}),i(co)!=="svelte-18uwvbi"&&(co.textContent=nm),fl.forEach(l),Bs=n(k),Ee=r(k,"DIV",{class:!0});var vl=_(Ee);d(_a.$$.fragment,vl),Zs=n(vl),mo=r(vl,"P",{"data-svelte-h":!0}),i(mo)!=="svelte-nqksfz"&&(mo.innerHTML=om),vl.forEach(l),Js=n(k),Re=r(k,"DIV",{class:!0});var bl=_(Re);d(ha.$$.fragment,bl),Qs=n(bl),po=r(bl,"P",{"data-svelte-h":!0}),i(po)!=="svelte-y2dr0o"&&(po.textContent=rm),bl.forEach(l),Xs=n(k),M=r(k,"DIV",{class:!0});var Ye=_(M);d(ua.$$.fragment,Ye),Ys=n(Ye),go=r(Ye,"P",{"data-svelte-h":!0}),i(go)!=="svelte-xlsvih"&&(go.textContent=lm),ed=n(Ye),_o=r(Ye,"P",{"data-svelte-h":!0}),i(_o)!=="svelte-1mn1gnw"&&(_o.textContent=im),td=n(Ye),ho=r(Ye,"P",{"data-svelte-h":!0}),i(ho)!=="svelte-1xvpyih"&&(ho.textContent=sm),Ye.forEach(l),k.forEach(l),Pr=n(e),d(fa.$$.fragment,e),wr=n(e),ae=r(e,"DIV",{class:!0});var Tl=_(ae);d(va.$$.fragment,Tl),ad=n(Tl),uo=r(Tl,"P",{"data-svelte-h":!0}),i(uo)!=="svelte-aondqr"&&(uo.textContent=dm),Tl.forEach(l),yr=n(e),d(ba.$$.fragment,e),Cr=n(e),O=r(e,"DIV",{class:!0});var w=_(O);d(Ta.$$.fragment,w),nd=n(w),fo=r(w,"P",{"data-svelte-h":!0}),i(fo)!=="svelte-hys9rl"&&(fo.innerHTML=cm),od=n(w),Ue=r(w,"DIV",{class:!0});var Ol=_(Ue);d(Oa.$$.fragment,Ol),rd=n(Ol),vo=r(Ol,"P",{"data-svelte-h":!0}),i(vo)!=="svelte-185nst0"&&(vo.textContent=mm),Ol.forEach(l),ld=n(w),He=r(w,"DIV",{class:!0});var xl=_(He);d(xa.$$.fragment,xl),id=n(xl),bo=r(xl,"P",{"data-svelte-h":!0}),i(bo)!=="svelte-3nt516"&&(bo.textContent=pm),xl.forEach(l),sd=n(w),Ve=r(w,"DIV",{class:!0});var $l=_(Ve);d($a.$$.fragment,$l),dd=n($l),To=r($l,"P",{"data-svelte-h":!0}),i(To)!=="svelte-3jfrz9"&&(To.textContent=gm),$l.forEach(l),cd=n(w),Ae=r(w,"DIV",{class:!0});var Pl=_(Ae);d(Pa.$$.fragment,Pl),md=n(Pl),Oo=r(Pl,"P",{"data-svelte-h":!0}),i(Oo)!=="svelte-lcc1u3"&&(Oo.textContent=_m),Pl.forEach(l),pd=n(w),Ke=r(w,"DIV",{class:!0});var wl=_(Ke);d(wa.$$.fragment,wl),gd=n(wl),xo=r(wl,"P",{"data-svelte-h":!0}),i(xo)!=="svelte-1gqqzmu"&&(xo.innerHTML=hm),wl.forEach(l),_d=n(w),je=r(w,"DIV",{class:!0});var yl=_(je);d(ya.$$.fragment,yl),hd=n(yl),$o=r(yl,"P",{"data-svelte-h":!0}),i($o)!=="svelte-ffqz5"&&($o.textContent=um),yl.forEach(l),ud=n(w),Se=r(w,"DIV",{class:!0});var Cl=_(Se);d(Ca.$$.fragment,Cl),fd=n(Cl),Po=r(Cl,"P",{"data-svelte-h":!0}),i(Po)!=="svelte-febvhf"&&(Po.textContent=fm),Cl.forEach(l),vd=n(w),We=r(w,"DIV",{class:!0});var kl=_(We);d(ka.$$.fragment,kl),bd=n(kl),wo=r(kl,"P",{"data-svelte-h":!0}),i(wo)!=="svelte-1hbodkw"&&(wo.textContent=vm),kl.forEach(l),Td=n(w),Ge=r(w,"DIV",{class:!0});var Nl=_(Ge);d(Na.$$.fragment,Nl),Od=n(Nl),yo=r(Nl,"P",{"data-svelte-h":!0}),i(yo)!=="svelte-1hfgx92"&&(yo.textContent=bm),Nl.forEach(l),xd=n(w),Be=r(w,"DIV",{class:!0});var Dl=_(Be);d(Da.$$.fragment,Dl),$d=n(Dl),Co=r(Dl,"P",{"data-svelte-h":!0}),i(Co)!=="svelte-yrsdu6"&&(Co.textContent=Tm),Dl.forEach(l),Pd=n(w),Ze=r(w,"DIV",{class:!0});var Fl=_(Ze);d(Fa.$$.fragment,Fl),wd=n(Fl),ko=r(Fl,"P",{"data-svelte-h":!0}),i(ko)!=="svelte-3k7k5e"&&(ko.textContent=Om),Fl.forEach(l),w.forEach(l),kr=n(e),d(La.$$.fragment,e),Nr=n(e),V=r(e,"DIV",{class:!0});var Xo=_(V);d(za.$$.fragment,Xo),yd=n(Xo),No=r(Xo,"P",{"data-svelte-h":!0}),i(No)!=="svelte-u4tkv1"&&(No.innerHTML=xm),Cd=n(Xo),Do=r(Xo,"P",{"data-svelte-h":!0}),i(Do)!=="svelte-1xl7jqc"&&(Do.innerHTML=$m),Xo.forEach(l),Dr=n(e),d(Ia.$$.fragment,e),Fr=n(e),F=r(e,"DIV",{class:!0});var Y=_(F);d(Ma.$$.fragment,Y),kd=n(Y),Fo=r(Y,"P",{"data-svelte-h":!0}),i(Fo)!=="svelte-qafafj"&&(Fo.innerHTML=Pm),Nd=n(Y),Lo=r(Y,"P",{"data-svelte-h":!0}),i(Lo)!=="svelte-bkmbwh"&&(Lo.innerHTML=wm),Dd=n(Y),zo=r(Y,"UL",{"data-svelte-h":!0}),i(zo)!=="svelte-1ytuxgw"&&(zo.innerHTML=ym),Fd=n(Y),Io=r(Y,"P",{"data-svelte-h":!0}),i(Io)!=="svelte-18tbp4c"&&(Io.innerHTML=Cm),Y.forEach(l),Lr=n(e),d(qa.$$.fragment,e),zr=n(e),ne=r(e,"DIV",{class:!0});var Ll=_(ne);d(Ea.$$.fragment,Ll),Ld=n(Ll),Mo=r(Ll,"P",{"data-svelte-h":!0}),i(Mo)!=="svelte-14oyph8"&&(Mo.innerHTML=km),Ll.forEach(l),Ir=n(e),d(Ra.$$.fragment,e),Mr=n(e),oe=r(e,"DIV",{class:!0});var zl=_(oe);d(Ua.$$.fragment,zl),zd=n(zl),qo=r(zl,"P",{"data-svelte-h":!0}),i(qo)!=="svelte-1aeuhep"&&(qo.innerHTML=Nm),zl.forEach(l),qr=n(e),d(Ha.$$.fragment,e),Er=n(e),er=r(e,"P",{}),_(er).forEach(l),this.h()},h(){h(ee,"name","hf:doc:metadata"),h(ee,"content",Rm),h(E,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(re,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(le,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(K,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(se,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(de,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(ce,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(me,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(te,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(pe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(ge,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(_e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(he,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(ue,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(j,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(fe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(ve,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(be,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Te,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Oe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(W,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(G,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(xe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h($e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(I,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(b,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Pe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(R,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(we,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(B,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(ye,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Ce,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(ke,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(J,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Ne,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(De,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Fe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(H,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Le,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(ze,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(X,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Me,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(qe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Ee,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Re,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(P,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(ae,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Ue,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(He,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Ve,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Ae,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Ke,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(je,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Se,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(We,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Ge,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Be,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Ze,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(O,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(V,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(F,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(ne,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(oe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,u){t(document.head,ee),v(e,tr,u),v(e,Yo,u),v(e,ar,u),c(et,e,u),v(e,nr,u),v(e,tt,u),v(e,or,u),c(at,e,u),v(e,rr,u),v(e,E,u),c(nt,E,null),t(E,Il),t(E,Va),t(E,Ml),t(E,Aa),v(e,lr,u),c(ot,e,u),v(e,ir,u),v(e,x,u),c(rt,x,null),t(x,ql),t(x,Ka),t(x,El),t(x,re),c(lt,re,null),t(re,Rl),t(re,ja),t(x,Ul),t(x,A),c(it,A,null),t(A,Hl),t(A,Sa),t(A,Vl),t(A,Wa),t(x,Al),t(x,le),c(st,le,null),t(le,Kl),t(le,Ga),t(x,jl),t(x,ie),c(dt,ie,null),t(ie,Sl),t(ie,Ba),t(x,Wl),t(x,K),c(ct,K,null),t(K,Gl),t(K,Za),t(K,Bl),t(K,Ja),t(x,Zl),t(x,se),c(mt,se,null),t(se,Jl),t(se,Qa),t(x,Ql),t(x,de),c(pt,de,null),t(de,Xl),t(de,Xa),t(x,Yl),t(x,ce),c(gt,ce,null),t(ce,ei),t(ce,Ya),t(x,ti),t(x,me),c(_t,me,null),t(me,ai),t(me,en),t(x,ni),t(x,L),c(ht,L,null),t(L,oi),t(L,tn),t(L,ri),t(L,an),t(L,li),t(L,nn),v(e,sr,u),c(ut,e,u),v(e,dr,u),v(e,te,u),c(ft,te,null),t(te,ii),t(te,on),v(e,cr,u),c(vt,e,u),v(e,mr,u),v(e,N,u),c(bt,N,null),t(N,si),t(N,rn),t(N,di),t(N,pe),c(Tt,pe,null),t(pe,ci),t(pe,ln),t(N,mi),t(N,ge),c(Ot,ge,null),t(ge,pi),t(ge,sn),t(N,gi),t(N,z),c(xt,z,null),t(z,_i),t(z,dn),t(z,hi),t(z,cn),t(z,ui),t(z,mn),t(N,fi),t(N,_e),c($t,_e,null),t(_e,vi),t(_e,pn),v(e,pr,u),c(Pt,e,u),v(e,gr,u),v(e,b,u),c(wt,b,null),t(b,bi),t(b,gn),t(b,Ti),t(b,he),c(yt,he,null),t(he,Oi),t(he,_n),t(b,xi),t(b,ue),c(Ct,ue,null),t(ue,$i),t(ue,hn),t(b,Pi),t(b,j),c(kt,j,null),t(j,wi),t(j,un),t(j,yi),t(j,fn),t(b,Ci),t(b,fe),c(Nt,fe,null),t(fe,ki),t(fe,vn),t(b,Ni),t(b,ve),c(Dt,ve,null),t(ve,Di),t(ve,bn),t(b,Fi),t(b,S),c(Ft,S,null),t(S,Li),t(S,Tn),t(S,zi),t(S,On),t(b,Ii),t(b,be),c(Lt,be,null),t(be,Mi),t(be,xn),t(b,qi),t(b,Te),c(zt,Te,null),t(Te,Ei),t(Te,$n),t(b,Ri),t(b,Oe),c(It,Oe,null),t(Oe,Ui),t(Oe,Pn),t(b,Hi),t(b,W),c(Mt,W,null),t(W,Vi),t(W,wn),t(W,Ai),t(W,yn),t(b,Ki),t(b,G),c(qt,G,null),t(G,ji),t(G,Cn),t(G,Si),t(G,kn),t(b,Wi),t(b,xe),c(Et,xe,null),t(xe,Gi),t(xe,Nn),t(b,Bi),t(b,$e),c(Rt,$e,null),t($e,Zi),t($e,Dn),t(b,Ji),t(b,I),c(Ut,I,null),t(I,Qi),t(I,Fn),t(I,Xi),t(I,Ln),t(I,Yi),t(I,zn),v(e,_r,u),c(Ht,e,u),v(e,hr,u),v(e,R,u),c(Vt,R,null),t(R,es),t(R,In),t(R,ts),t(R,Pe),c(At,Pe,null),t(Pe,as),t(Pe,Mn),v(e,ur,u),c(Kt,e,u),v(e,fr,u),v(e,U,u),c(jt,U,null),t(U,ns),t(U,qn),t(U,os),t(U,En),v(e,vr,u),c(St,e,u),v(e,br,u),v(e,$,u),c(Wt,$,null),t($,rs),t($,Rn),t($,ls),t($,we),c(Gt,we,null),t(we,is),t(we,Un),t($,ss),t($,B),c(Bt,B,null),t(B,ds),t(B,Hn),t(B,cs),t(B,Vn),t($,ms),t($,ye),c(Zt,ye,null),t(ye,ps),t(ye,An),t($,gs),t($,Ce),c(Jt,Ce,null),t(Ce,_s),t(Ce,Kn),t($,hs),t($,ke),c(Qt,ke,null),t(ke,us),t(ke,jn),t($,fs),t($,Z),c(Xt,Z,null),t(Z,vs),t(Z,Sn),t(Z,bs),t(Z,Wn),t($,Ts),t($,J),c(Yt,J,null),t(J,Os),t(J,Gn),t(J,xs),t(J,Bn),t($,$s),t($,Ne),c(ea,Ne,null),t(Ne,Ps),t(Ne,Zn),t($,ws),t($,De),c(ta,De,null),t(De,ys),t(De,Jn),t($,Cs),t($,Fe),c(aa,Fe,null),t(Fe,ks),t(Fe,Qn),v(e,Tr,u),c(na,e,u),v(e,Or,u),v(e,H,u),c(oa,H,null),t(H,Ns),t(H,Xn),t(H,Ds),t(H,Yn),v(e,xr,u),c(ra,e,u),v(e,$r,u),v(e,P,u),c(la,P,null),t(P,Fs),t(P,eo),t(P,Ls),t(P,Le),c(ia,Le,null),t(Le,zs),t(Le,to),t(P,Is),t(P,Q),c(sa,Q,null),t(Q,Ms),t(Q,ao),t(Q,qs),t(Q,no),t(P,Es),t(P,ze),c(da,ze,null),t(ze,Rs),t(ze,oo),t(P,Us),t(P,X),c(ca,X,null),t(X,Hs),t(X,ro),t(X,Vs),t(X,lo),t(P,As),t(P,Ie),c(ma,Ie,null),t(Ie,Ks),t(Ie,io),t(P,js),t(P,Me),c(pa,Me,null),t(Me,Ss),t(Me,so),t(P,Ws),t(P,qe),c(ga,qe,null),t(qe,Gs),t(qe,co),t(P,Bs),t(P,Ee),c(_a,Ee,null),t(Ee,Zs),t(Ee,mo),t(P,Js),t(P,Re),c(ha,Re,null),t(Re,Qs),t(Re,po),t(P,Xs),t(P,M),c(ua,M,null),t(M,Ys),t(M,go),t(M,ed),t(M,_o),t(M,td),t(M,ho),v(e,Pr,u),c(fa,e,u),v(e,wr,u),v(e,ae,u),c(va,ae,null),t(ae,ad),t(ae,uo),v(e,yr,u),c(ba,e,u),v(e,Cr,u),v(e,O,u),c(Ta,O,null),t(O,nd),t(O,fo),t(O,od),t(O,Ue),c(Oa,Ue,null),t(Ue,rd),t(Ue,vo),t(O,ld),t(O,He),c(xa,He,null),t(He,id),t(He,bo),t(O,sd),t(O,Ve),c($a,Ve,null),t(Ve,dd),t(Ve,To),t(O,cd),t(O,Ae),c(Pa,Ae,null),t(Ae,md),t(Ae,Oo),t(O,pd),t(O,Ke),c(wa,Ke,null),t(Ke,gd),t(Ke,xo),t(O,_d),t(O,je),c(ya,je,null),t(je,hd),t(je,$o),t(O,ud),t(O,Se),c(Ca,Se,null),t(Se,fd),t(Se,Po),t(O,vd),t(O,We),c(ka,We,null),t(We,bd),t(We,wo),t(O,Td),t(O,Ge),c(Na,Ge,null),t(Ge,Od),t(Ge,yo),t(O,xd),t(O,Be),c(Da,Be,null),t(Be,$d),t(Be,Co),t(O,Pd),t(O,Ze),c(Fa,Ze,null),t(Ze,wd),t(Ze,ko),v(e,kr,u),c(La,e,u),v(e,Nr,u),v(e,V,u),c(za,V,null),t(V,yd),t(V,No),t(V,Cd),t(V,Do),v(e,Dr,u),c(Ia,e,u),v(e,Fr,u),v(e,F,u),c(Ma,F,null),t(F,kd),t(F,Fo),t(F,Nd),t(F,Lo),t(F,Dd),t(F,zo),t(F,Fd),t(F,Io),v(e,Lr,u),c(qa,e,u),v(e,zr,u),v(e,ne,u),c(Ea,ne,null),t(ne,Ld),t(ne,Mo),v(e,Ir,u),c(Ra,e,u),v(e,Mr,u),v(e,oe,u),c(Ua,oe,null),t(oe,zd),t(oe,qo),v(e,qr,u),c(Ha,e,u),v(e,Er,u),v(e,er,u),Rr=!0},p:Fm,i(e){Rr||(m(et.$$.fragment,e),m(at.$$.fragment,e),m(nt.$$.fragment,e),m(ot.$$.fragment,e),m(rt.$$.fragment,e),m(lt.$$.fragment,e),m(it.$$.fragment,e),m(st.$$.fragment,e),m(dt.$$.fragment,e),m(ct.$$.fragment,e),m(mt.$$.fragment,e),m(pt.$$.fragment,e),m(gt.$$.fragment,e),m(_t.$$.fragment,e),m(ht.$$.fragment,e),m(ut.$$.fragment,e),m(ft.$$.fragment,e),m(vt.$$.fragment,e),m(bt.$$.fragment,e),m(Tt.$$.fragment,e),m(Ot.$$.fragment,e),m(xt.$$.fragment,e),m($t.$$.fragment,e),m(Pt.$$.fragment,e),m(wt.$$.fragment,e),m(yt.$$.fragment,e),m(Ct.$$.fragment,e),m(kt.$$.fragment,e),m(Nt.$$.fragment,e),m(Dt.$$.fragment,e),m(Ft.$$.fragment,e),m(Lt.$$.fragment,e),m(zt.$$.fragment,e),m(It.$$.fragment,e),m(Mt.$$.fragment,e),m(qt.$$.fragment,e),m(Et.$$.fragment,e),m(Rt.$$.fragment,e),m(Ut.$$.fragment,e),m(Ht.$$.fragment,e),m(Vt.$$.fragment,e),m(At.$$.fragment,e),m(Kt.$$.fragment,e),m(jt.$$.fragment,e),m(St.$$.fragment,e),m(Wt.$$.fragment,e),m(Gt.$$.fragment,e),m(Bt.$$.fragment,e),m(Zt.$$.fragment,e),m(Jt.$$.fragment,e),m(Qt.$$.fragment,e),m(Xt.$$.fragment,e),m(Yt.$$.fragment,e),m(ea.$$.fragment,e),m(ta.$$.fragment,e),m(aa.$$.fragment,e),m(na.$$.fragment,e),m(oa.$$.fragment,e),m(ra.$$.fragment,e),m(la.$$.fragment,e),m(ia.$$.fragment,e),m(sa.$$.fragment,e),m(da.$$.fragment,e),m(ca.$$.fragment,e),m(ma.$$.fragment,e),m(pa.$$.fragment,e),m(ga.$$.fragment,e),m(_a.$$.fragment,e),m(ha.$$.fragment,e),m(ua.$$.fragment,e),m(fa.$$.fragment,e),m(va.$$.fragment,e),m(ba.$$.fragment,e),m(Ta.$$.fragment,e),m(Oa.$$.fragment,e),m(xa.$$.fragment,e),m($a.$$.fragment,e),m(Pa.$$.fragment,e),m(wa.$$.fragment,e),m(ya.$$.fragment,e),m(Ca.$$.fragment,e),m(ka.$$.fragment,e),m(Na.$$.fragment,e),m(Da.$$.fragment,e),m(Fa.$$.fragment,e),m(La.$$.fragment,e),m(za.$$.fragment,e),m(Ia.$$.fragment,e),m(Ma.$$.fragment,e),m(qa.$$.fragment,e),m(Ea.$$.fragment,e),m(Ra.$$.fragment,e),m(Ua.$$.fragment,e),m(Ha.$$.fragment,e),Rr=!0)},o(e){p(et.$$.fragment,e),p(at.$$.fragment,e),p(nt.$$.fragment,e),p(ot.$$.fragment,e),p(rt.$$.fragment,e),p(lt.$$.fragment,e),p(it.$$.fragment,e),p(st.$$.fragment,e),p(dt.$$.fragment,e),p(ct.$$.fragment,e),p(mt.$$.fragment,e),p(pt.$$.fragment,e),p(gt.$$.fragment,e),p(_t.$$.fragment,e),p(ht.$$.fragment,e),p(ut.$$.fragment,e),p(ft.$$.fragment,e),p(vt.$$.fragment,e),p(bt.$$.fragment,e),p(Tt.$$.fragment,e),p(Ot.$$.fragment,e),p(xt.$$.fragment,e),p($t.$$.fragment,e),p(Pt.$$.fragment,e),p(wt.$$.fragment,e),p(yt.$$.fragment,e),p(Ct.$$.fragment,e),p(kt.$$.fragment,e),p(Nt.$$.fragment,e),p(Dt.$$.fragment,e),p(Ft.$$.fragment,e),p(Lt.$$.fragment,e),p(zt.$$.fragment,e),p(It.$$.fragment,e),p(Mt.$$.fragment,e),p(qt.$$.fragment,e),p(Et.$$.fragment,e),p(Rt.$$.fragment,e),p(Ut.$$.fragment,e),p(Ht.$$.fragment,e),p(Vt.$$.fragment,e),p(At.$$.fragment,e),p(Kt.$$.fragment,e),p(jt.$$.fragment,e),p(St.$$.fragment,e),p(Wt.$$.fragment,e),p(Gt.$$.fragment,e),p(Bt.$$.fragment,e),p(Zt.$$.fragment,e),p(Jt.$$.fragment,e),p(Qt.$$.fragment,e),p(Xt.$$.fragment,e),p(Yt.$$.fragment,e),p(ea.$$.fragment,e),p(ta.$$.fragment,e),p(aa.$$.fragment,e),p(na.$$.fragment,e),p(oa.$$.fragment,e),p(ra.$$.fragment,e),p(la.$$.fragment,e),p(ia.$$.fragment,e),p(sa.$$.fragment,e),p(da.$$.fragment,e),p(ca.$$.fragment,e),p(ma.$$.fragment,e),p(pa.$$.fragment,e),p(ga.$$.fragment,e),p(_a.$$.fragment,e),p(ha.$$.fragment,e),p(ua.$$.fragment,e),p(fa.$$.fragment,e),p(va.$$.fragment,e),p(ba.$$.fragment,e),p(Ta.$$.fragment,e),p(Oa.$$.fragment,e),p(xa.$$.fragment,e),p($a.$$.fragment,e),p(Pa.$$.fragment,e),p(wa.$$.fragment,e),p(ya.$$.fragment,e),p(Ca.$$.fragment,e),p(ka.$$.fragment,e),p(Na.$$.fragment,e),p(Da.$$.fragment,e),p(Fa.$$.fragment,e),p(La.$$.fragment,e),p(za.$$.fragment,e),p(Ia.$$.fragment,e),p(Ma.$$.fragment,e),p(qa.$$.fragment,e),p(Ea.$$.fragment,e),p(Ra.$$.fragment,e),p(Ua.$$.fragment,e),p(Ha.$$.fragment,e),Rr=!1},d(e){e&&(l(tr),l(Yo),l(ar),l(nr),l(tt),l(or),l(rr),l(E),l(lr),l(ir),l(x),l(sr),l(dr),l(te),l(cr),l(mr),l(N),l(pr),l(gr),l(b),l(_r),l(hr),l(R),l(ur),l(fr),l(U),l(vr),l(br),l($),l(Tr),l(Or),l(H),l(xr),l($r),l(P),l(Pr),l(wr),l(ae),l(yr),l(Cr),l(O),l(kr),l(Nr),l(V),l(Dr),l(Fr),l(F),l(Lr),l(zr),l(ne),l(Ir),l(Mr),l(oe),l(qr),l(Er),l(er)),l(ee),g(et,e),g(at,e),g(nt),g(ot,e),g(rt),g(lt),g(it),g(st),g(dt),g(ct),g(mt),g(pt),g(gt),g(_t),g(ht),g(ut,e),g(ft),g(vt,e),g(bt),g(Tt),g(Ot),g(xt),g($t),g(Pt,e),g(wt),g(yt),g(Ct),g(kt),g(Nt),g(Dt),g(Ft),g(Lt),g(zt),g(It),g(Mt),g(qt),g(Et),g(Rt),g(Ut),g(Ht,e),g(Vt),g(At),g(Kt,e),g(jt),g(St,e),g(Wt),g(Gt),g(Bt),g(Zt),g(Jt),g(Qt),g(Xt),g(Yt),g(ea),g(ta),g(aa),g(na,e),g(oa),g(ra,e),g(la),g(ia),g(sa),g(da),g(ca),g(ma),g(pa),g(ga),g(_a),g(ha),g(ua),g(fa,e),g(va),g(ba,e),g(Ta),g(Oa),g(xa),g($a),g(Pa),g(wa),g(ya),g(Ca),g(ka),g(Na),g(Da),g(Fa),g(La,e),g(za),g(Ia,e),g(Ma),g(qa,e),g(Ea),g(Ra,e),g(Ua),g(Ha,e)}}}const Rm='{"title":"Trainer","local":"trainer","sections":[{"title":"CPOConfig","local":"trl.CPOConfig","sections":[],"depth":2},{"title":"CPOTrainer","local":"trl.CPOTrainer","sections":[],"depth":2},{"title":"DDPOConfig","local":"trl.DDPOConfig","sections":[],"depth":2},{"title":"DDPOTrainer","local":"trl.DDPOTrainer","sections":[],"depth":2},{"title":"DPOTrainer","local":"trl.DPOTrainer","sections":[],"depth":2},{"title":"IterativeSFTTrainer","local":"trl.IterativeSFTTrainer","sections":[],"depth":2},{"title":"KTOConfig","local":"trl.KTOConfig","sections":[],"depth":2},{"title":"KTOTrainer","local":"trl.KTOTrainer","sections":[],"depth":2},{"title":"ORPOConfig","local":"trl.ORPOConfig","sections":[],"depth":2},{"title":"ORPOTrainer","local":"trl.ORPOTrainer","sections":[],"depth":2},{"title":"PPOConfig","local":"trl.PPOConfig","sections":[],"depth":2},{"title":"PPOTrainer","local":"trl.PPOTrainer","sections":[],"depth":2},{"title":"RewardConfig","local":"trl.RewardConfig","sections":[],"depth":2},{"title":"RewardTrainer","local":"trl.RewardTrainer","sections":[],"depth":2},{"title":"SFTTrainer","local":"trl.SFTTrainer","sections":[],"depth":2},{"title":"set_seed","local":"trl.set_seed","sections":[],"depth":2}],"depth":1}';function Um(Id){return Lm(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class jm extends zm{constructor(ee){super(),Im(this,ee,Um,Em,Dm,{})}}export{jm as component};
